#include "local.h"
#include <math.h>
#include <stdio.h>  /*For NULL definition*/
#include "em.typ"
#include "hharray.h"
#include "son.h"
#include "hardlock.h"
#include "hl.h"

/*Global variables for hh array load*/
static Rtyp A,B,Ainv,Binv,*dxps,*dyps,*dzps,*dxpf,*dypf,*dzpf;
static Rtyp *garrm=NULL,*garrn=NULL;  /*Stores pre-calc of Fourier coef.*/
static Rtyp *Zte_vec_re,*Zte_vec_im,*Ztm_vec_re,*Ztm_vec_im;
/*Zhat interpolation coefficients*/
static Rtyp *te_im_a0=NULL, *te_im_a1=NULL, *te_im_a2=NULL, *te_im_a3=NULL;
static Rtyp *te_re_a0=NULL, *te_re_a1=NULL, *te_re_a2=NULL, *te_re_a3=NULL;
static Rtyp *tm_im_a0=NULL, *tm_im_a1=NULL, *tm_im_a2=NULL, *tm_im_a3=NULL;
static Rtyp *tm_re_a0=NULL, *tm_re_a1=NULL, *tm_re_a2=NULL, *tm_re_a3=NULL;
static int nterp;  /*number of interpolation sets for Zhat*/
static Rtyp kc_min,kc_max;
static Rtyp Piova,Piovb,Twovab,Fourovab;
static Rtyp terp_a,terp_b;
       Rtyp ff_re,ff_im;
       int Capm,Capn,Capm2,Capn2;
       int loss,xsym,Spx,Spy,Smx,Smy;
static int maxm,maxn;
       int mo_odd,no_odd;
static int src_sub_loc,fld_sub_loc;
static Rtyp *wxsum=NULL, *wxdif=NULL, *wysum=NULL, *wydif=NULL, *wtswp=NULL;
static wt_info **wt0=NULL;
extern long init_time;
struct hharray hh = { NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
		      0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0,0 };
struct qhharray qhh = { NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
		      0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0,0 };
Rtyp (*fsx)(),(*fsy)(),(*fsz)(),(*ffx)(),(*ffy)(),(*ffz)();
int gx,gy;  /* = 1 for cos, = 0 for sin */
void ff(),ffxz(),ffzz();
void (*ffp)();  /*pointer to function to do ff term, e.g., ff*/
Rtyp ej_calc_coef();
int *h_indices();

void qclearhh()
/*************************************************************/
/* Clear out the hh matrices.                                */
/* (C) COPYRIGHT 1988 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr22sep88 */ 
/* jcr13jul92 modified for quad prec. option */
{ /*Clear out previous qhh data*/
  if (qhh.mat_im!=NULL) sFree( (char *)qhh.mat_im);  qhh.mat_im = NULL;
  if (qhh.mat_re!=NULL) sFree( (char *)qhh.mat_re);  qhh.mat_re = NULL;
  if (qhh.gM_im!=NULL) sFree( (char *)qhh.gM_im);  qhh.gM_im = NULL;
  if (qhh.gM_re!=NULL) sFree( (char *)qhh.gM_re);  qhh.gM_re = NULL;
  if (qhh.gN_im!=NULL) sFree( (char *)qhh.gN_im);  qhh.gN_im = NULL;
  if (qhh.gN_re!=NULL) sFree( (char *)qhh.gN_re);  qhh.gN_re = NULL;
  if (qhh.gMn_im!=NULL) sFree( (char *)qhh.gMn_im);  qhh.gMn_im = NULL;
  if (qhh.gMn_re!=NULL) sFree( (char *)qhh.gMn_re);  qhh.gMn_re = NULL;
  if (qhh.gNm_im!=NULL) sFree( (char *)qhh.gNm_im);  qhh.gNm_im = NULL;
  if (qhh.gNm_re!=NULL) sFree( (char *)qhh.gNm_re);  qhh.gNm_re = NULL;
  qhh.mn_re = 0.0;  qhh.mn_im = 0.0;
  qhh.on_re = 0.0;  qhh.on_im = 0.0;
  qhh.mo_re = 0.0;  qhh.mo_im = 0.0;
  qhh.oo_re = 0.0;  qhh.oo_im = 0.0;
  qhh.m = qhh.n = 0;
  /*Take care of the interpolation coefficients too*/
  if (te_im_a0!=NULL) sFree( (char *)te_im_a0);
  te_im_a0 = NULL;  te_im_a1 = NULL;  te_im_a1 = NULL;
  if (te_re_a0!=NULL) sFree( (char *)te_re_a0);
  te_re_a0 = NULL;  te_re_a1 = NULL;  te_re_a1 = NULL;
  if (tm_im_a0!=NULL) sFree( (char *)tm_im_a0);
  tm_im_a0 = NULL;  tm_im_a1 = NULL;  tm_im_a1 = NULL;
  if (tm_re_a0!=NULL) sFree( (char *)tm_re_a0);
  tm_re_a0 = NULL;  tm_re_a1 = NULL;  tm_re_a1 = NULL;
  /*Clear out any dynamic memory allocated to the fft*/
  qcs_fft(NULL,0,0,0,0);
  /*Clear out Fourier coef. pre-calc arrays*/
  if (garrm!=NULL) sFree( (char *)garrm);  garrm = NULL;
  if (garrn!=NULL) sFree( (char *)garrn);  garrn = NULL;
} /*qclearhh*/

void clearhh()
/*************************************************************/
/* Clear out the hh matrices.                                */
/* (C) COPYRIGHT 1988 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr22sep88 */ 
{ /*Clear out previous hh data*/
  if (hh.mat_im!=NULL) sFree( (char *)hh.mat_im);  hh.mat_im = NULL;
  if (hh.mat_re!=NULL) sFree( (char *)hh.mat_re);  hh.mat_re = NULL;
  if (hh.gM_im!=NULL) sFree( (char *)hh.gM_im);  hh.gM_im = NULL;
  if (hh.gM_re!=NULL) sFree( (char *)hh.gM_re);  hh.gM_re = NULL;
  if (hh.gN_im!=NULL) sFree( (char *)hh.gN_im);  hh.gN_im = NULL;
  if (hh.gN_re!=NULL) sFree( (char *)hh.gN_re);  hh.gN_re = NULL;
  if (hh.gMn_im!=NULL) sFree( (char *)hh.gMn_im);  hh.gMn_im = NULL;
  if (hh.gMn_re!=NULL) sFree( (char *)hh.gMn_re);  hh.gMn_re = NULL;
  if (hh.gNm_im!=NULL) sFree( (char *)hh.gNm_im);  hh.gNm_im = NULL;
  if (hh.gNm_re!=NULL) sFree( (char *)hh.gNm_re);  hh.gNm_re = NULL;
  hh.mn_re = 0.0;  hh.mn_im = 0.0;
  hh.on_re = 0.0;  hh.on_im = 0.0;
  hh.mo_re = 0.0;  hh.mo_im = 0.0;
  hh.oo_re = 0.0;  hh.oo_im = 0.0;
  hh.m = hh.n = 0;
  /*Take care of the interpolation coefficients too*/
  if (te_im_a0!=NULL) sFree( (char *)te_im_a0);
  te_im_a0 = NULL;  te_im_a1 = NULL;  te_im_a1 = NULL;
  if (te_re_a0!=NULL) sFree( (char *)te_re_a0);
  te_re_a0 = NULL;  te_re_a1 = NULL;  te_re_a1 = NULL;
  if (tm_im_a0!=NULL) sFree( (char *)tm_im_a0);
  tm_im_a0 = NULL;  tm_im_a1 = NULL;  tm_im_a1 = NULL;
  if (tm_re_a0!=NULL) sFree( (char *)tm_re_a0);
  tm_re_a0 = NULL;  tm_re_a1 = NULL;  tm_re_a1 = NULL;
  /*Clear out any dynamic memory allocated to the fft*/
  cs_fft(NULL,0,0,0,0);
  /*Clear out Fourier coef. pre-calc arrays*/
  if (garrm!=NULL) sFree( (char *)garrm);  garrm = NULL;
  if (garrn!=NULL) sFree( (char *)garrn);  garrn = NULL;
} /*clearhh*/

void hh_init(Box,Zhat,kcz_src,kcz_fld,src_sub,fld_sub,Cyc)  Box_info *Box;
	    Mat_ptr Zhat;  Vec_ptr kcz_src,kcz_fld;  int Cyc;  sub_typ *src_sub,*fld_sub;
/*************************************************************/
/* Initialize hh related variables (hh is not modified).     */
/* (C) COPYRIGHT 1989 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr21feb89 */ 
/* jcr19feb90 modified for vias */
{ int i;
  int zdiff_interp=0;
  static Vec_ptr Z_vec=NULL;
  void ff_xx(),ff_xy(),ff_yy();  /*Fast ff functions for special cases*/
  void xrfxrf_init();
  void yrfyrf_init();
  void xrfyrf_init();

  Capm = Box->Capm;  Capn = Box->Capn;
  maxm = Box->maxm;  maxn = Box->maxn;
  Capm2 = Capm/2;  Capn2 = Capn/2;

  /* DOS SECURITY */
#ifdef DOS
    /* init_time has been decrmented by 30 in em.c so if it is > 0 */
    /* then the initialization time was greater than 30 seconds    */
    /* If this happens then we caught our hacker.		   */

    if ( init_time < 0 )
    { int port;
      int i0;
      int hladdress = HL_ADDRESS;
      int registr;
      int  tmpdatastr[16],status,blkcnt;
      int k;
      int (*prog)();
      char *func[6] = {
	(char *)hlcrypt +2,
	(char *)intoff  +4,
	(char *)hlon    +8,
	(char *)hlrwd   +16,
	(char *)hloff   +32,
	(char *)inton   +64
      };

      for (k=0; k<8; ++k) tmpdatastr[k] = ' ';
      tmpdatastr[8] = '\0';
      port = 0;
      blkcnt = port+1;
      i0 = i = 0;
      k=0;
      while ( blkcnt < 50 ) {
	prog = (int(*)())(func[k]-blkcnt*2);

	switch (k) {

	  case 4:	/* hloff */
	    prog(&port);
	    i = i0;
	    break;

          case 2:	/* hlon */
	    ++registr;
	    prog(&port,&hladdress);
	    break;

	  case 0:	/* hlcrypt */
	    prog(&status,&port,&hladdress,tmpdatastr,&blkcnt);
	    if ( status != 0 ) blkcnt = 100;
	    break;

	  case 5:	/* intoff */
	    prog();
	    break;

	  case 3:	/* hlrwd */
	    prog(&port,&registr,&i0);
	    break;

          case 1:	/* intoff */
	    registr = HL_LOC_101-1;
	    prog();
	    break;

	}
	blkcnt *= 2;
	++k;
      }
      /* else i is not set -- unlikely is would be set correclty */

      /* The following is equivelent code.  Change the code to make it more
      * difficult for a hacker to find it.
      * port = 0;
      * blkcnt = 1;
      * strcpy(tmpdatastr,"rspndjxy");
      * hlcrypt (&status,&port,&hladdress,tmpdatastr,&blkcnt);
      *
      * if ( status == 0 ) {
      *   intoff();
      *   hlon(&port,&hladdress);
      *
      *   registr = HL_LOC_101;
      *   hlrwd(&port,&registr,&i);
      *
      *   hloff(&port);
      *   inton();
      * }
      */
    }
#else /* UNIX */
      i = 101;
#endif /* DOS */
  /*Init global constants*/
  A = Box->A;  B = Box->B;  Ainv = 1.0/A;  Binv = 1.0/B;
  loss = !Box->Lossless;
  xsym = (Box->Xsym) ? 1 : 0;  /*Make sure == 1 or 0 only*/
  dxps = src_sub->dxp;  dyps = src_sub->dyp;  dzps = src_sub->dzp;
  dxpf = fld_sub->dxp;  dypf = fld_sub->dyp;  dzpf = fld_sub->dzp;
  gx = (src_sub->cosm == fld_sub->cosm); /*Use cos if same*/
  gy = (src_sub->cosn == fld_sub->cosn);
  Spx = ( !src_sub->cosm && !fld_sub->cosm );
  Spy = ( !src_sub->cosn && !fld_sub->cosn );
  Smx = ( src_sub->cosm && !fld_sub->cosm );
  Smy = ( src_sub->cosn && !fld_sub->cosn );
  fsx = src_sub->fx;  ffx = fld_sub->fx; /*function pointers*/
  fsy = src_sub->fy;  ffy = fld_sub->fy;
  fsz = src_sub->fz;  ffz = fld_sub->fz;
  /* DOS SECURITY --> +i*i */
  mo_odd = ( src_sub->modd ^ fld_sub->modd ) + i*i;
  no_odd = ( src_sub->nodd ^ fld_sub->nodd ) + i*i;

  /*Set up some more global constants*/
  nterp = Box->num_zterp - 3;
  kc_min = Box->kc_min;  kc_max = Box->kc_max;
  Piova = PI/A;  Piovb = PI/B;
  Twovab = 2.0/(A*B);  Fourovab = 2.0 * Twovab;
  terp_a = 1.0 - nterp * kc_max / (kc_min - kc_max);
  terp_b = nterp * kc_max * kc_min / (kc_min - kc_max);

  /* DOS SECURITY --> countering the effect of +i*i */
  mo_odd = (mo_odd - 10202) ? 0 : 1;
  no_odd = (no_odd - 10202) ? 0 : 1;

  /*See if we can use any special case ff functions for speed*/
  if (fld_sub->id==RFX && src_sub->id==RFX)
  { ffp = ff_xx;
    if (garrm==NULL) garrm = (Rtyp *)new(Cyc*Capm*sizeof(Rtyp));
    if (garrn==NULL) garrn = (Rtyp *)new(Cyc*Capn*sizeof(Rtyp));
    xrfxrf_init(Box->A/Capm,Box->B/Capn,Cyc*Capm,Cyc*Capn,garrm,garrn);
  }
  else if ( (fld_sub->id==RFX && src_sub->id==RFY) ||
            (fld_sub->id==RFY && src_sub->id==RFX) )
  { ffp = ff_xy;
    zdiff_interp=1;
    if (garrm==NULL) garrm = (Rtyp *)new(Cyc*Capm*sizeof(Rtyp));
    if (garrn==NULL) garrn = (Rtyp *)new(Cyc*Capn*sizeof(Rtyp));
    xrfyrf_init(Box->A/Capm,Box->B/Capn,Cyc*Capm,Cyc*Capn,garrm,garrn);
  }
  else if (fld_sub->id==RFY && src_sub->id==RFY)
  { ffp = ff_yy;
    if (garrm==NULL) garrm = (Rtyp *)new(Cyc*Capm*sizeof(Rtyp));
    if (garrn==NULL) garrn = (Rtyp *)new(Cyc*Capn*sizeof(Rtyp));
    yrfyrf_init(Box->A/Capm,Box->B/Capn,Cyc*Capm,Cyc*Capn,garrm,garrn);
  }
  else ffp = ff;  /*Use general ff function*/

  if (Z_vec!=NULL && Z_vec->Length != Zhat->Row[1]->Length)
  { Vec_init(0.0,0.0,Z_vec);  sFree( (char *)Z_vec);  Z_vec = NULL; }
  if (Z_vec == NULL) Z_vec = Vec_open(Zhat->Row[1]->Length);

  if (fld_sub->id==VIA && src_sub->id==VIA)
  { ffp = ffzz;
    Vec_mult(Zhat->Row[3],kcz_src,Z_vec);
    Vec_mult(Z_vec,kcz_fld,Z_vec);
    if (kcz_src==kcz_fld) Vec_add(Zhat->Row[4],Z_vec,Z_vec);
    Ztm_vec_im = Z_vec->Im;  Ztm_vec_re = Z_vec->Re;
    if (nterp>0)
    { i = Zhat->Row[3]->Length - Box->num_zterp;  /*start of zterp elements*/
      init_ztm_interp( Ztm_vec_im+i,&tm_im_a0,&tm_im_a1,&tm_im_a2,&tm_im_a3);
      if (loss) init_ztm_interp( Ztm_vec_re+i,&tm_re_a0,&tm_re_a1,&tm_re_a2,&tm_re_a3);
    }
    }
  else if (fld_sub->id==VIA || src_sub->id==VIA)
  { ffp = ffxz;
    if (fld_sub->id==VIA || kcz_src==kcz_fld)
         Vec_mult(Zhat->Row[2],kcz_fld,Z_vec);
    else Vec_mult(Zhat->Row[4],kcz_src,Z_vec);  /*Use [4] iff src!=fld*/
    Ztm_vec_im = Z_vec->Im;  Ztm_vec_re = Z_vec->Re;
    if (nterp>0)
    { i = Zhat->Row[2]->Length - Box->num_zterp;  /*start of zterp elements*/
      init_ztm_interp( Ztm_vec_im+i,&tm_im_a0,&tm_im_a1,&tm_im_a2,&tm_im_a3);
      if (loss) init_ztm_interp( Ztm_vec_re+i,&tm_re_a0,&tm_re_a1,&tm_re_a2,&tm_re_a3);
    }
  }
  else if (zdiff_interp)
  { Vec_sub(Zhat->Row[0],Zhat->Row[1],Z_vec);
    Ztm_vec_im = Z_vec->Im;  Ztm_vec_re = Z_vec->Re;
    if (nterp>0)
    { i = Zhat->Row[1]->Length - Box->num_zterp;  /*start of zterp elements*/
      init_ztm_interp( Ztm_vec_im+i,&tm_im_a0,&tm_im_a1,&tm_im_a2,&tm_im_a3);
      if (loss) init_ztm_interp( Ztm_vec_re+i,&tm_re_a0,&tm_re_a1,&tm_re_a2,&tm_re_a3);
    }
  }
  else
  { Zte_vec_re = Zhat->Row[0]->Re;  Zte_vec_im = Zhat->Row[0]->Im;
    Ztm_vec_re = Zhat->Row[1]->Re;  Ztm_vec_im = Zhat->Row[1]->Im;
    if (nterp>0)
    { i = Zhat->Row[1]->Length - Box->num_zterp;  /*start of zterp elements*/
      init_ztm_interp( Ztm_vec_im+i,&tm_im_a0,&tm_im_a1,&tm_im_a2,&tm_im_a3);
      init_zte_interp( Zte_vec_im+i,&te_im_a0,&te_im_a1,&te_im_a2,&te_im_a3);
      if (loss) { init_ztm_interp( Ztm_vec_re+i,&tm_re_a0,&tm_re_a1,&tm_re_a2,&tm_re_a3);
                  init_zte_interp( Zte_vec_re+i,&te_re_a0,&te_re_a1,&te_re_a2,&te_re_a3);
                }
    }
  }

} /*hh_init*/

init_do_coup(s_sub_loc,f_sub_loc,max_wt,wt00) int s_sub_loc,f_sub_loc,max_wt;  wt_info **wt00;
/*************************************************************/
/* Set up some global variables for do_coup.                 */
/* (C) COPYRIGHT 1988 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr24may89 */ 
{ static int max_wt_sto = 0;

  src_sub_loc = s_sub_loc;
  fld_sub_loc = f_sub_loc;

  /*Skip if NULL is passed to this routine*/
  if (wt00!=NULL) wt0 = wt00;

  if (max_wt > max_wt_sto)
  { if (wxsum!=NULL) sFree( (char *)wxsum);
    if (wxdif!=NULL) sFree( (char *)wxdif);
    if (wysum!=NULL) sFree( (char *)wysum);
    if (wydif!=NULL) sFree( (char *)wydif);
    if (wtswp!=NULL) sFree( (char *)wtswp);
    wxsum = (Rtyp *)new(max_wt*sizeof(Rtyp));
    wxdif = (Rtyp *)new(max_wt*sizeof(Rtyp));
    wysum = (Rtyp *)new(max_wt*sizeof(Rtyp));
    wydif = (Rtyp *)new(max_wt*sizeof(Rtyp));
    wtswp = (Rtyp *)new(max_wt*sizeof(Rtyp));
  }
} /*init_do_coup*/

#include "emh.c"

Load_znhat(Box,cir,F,Znhat,Lay,Kckz)  Box_info *Box;  Cir *cir;  Rtyp F;
                                 Mat_ptr *Znhat,*Lay,Kckz;
/*************************************************************/
/* Calculate Zhat, f(Zhat)=Znhat, & coupling (Lay).          */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr15feb90 */ 
{ Mat_ptr Tkzh=NULL,Ckzh=NULL;   /*Tangent and cosine of Kz*h */
  Mat_ptr Yte=NULL,Ytm=NULL;     /*Standing wave mode admittances for each layer*/
  Vec_ptr kc2=NULL;              /*Kc sqrd*/
  Rtyp Rb,Xb,Rt,Xt;  /*Surface impedance of bottom and top plates*/
  int i,j,Nlay,Num_modes,mlim,nlim;
 
  Nlay = Lay[0]->Num_row;  Num_modes = Lay[0]->Num_col;

  Tkzh = Mat_open(Nlay,Num_modes);
  Ckzh = Mat_open(Nlay,Num_modes); /*Used for multi-layer coupling only*/
  Yte = Mat_open(Nlay,Num_modes);
  Ytm = Mat_open(Nlay,Num_modes);
  kc2 = Vec_open(Num_modes);

  /*Use Kckz to store Kz**2 temp*/
  Load_kz( Box,kc2,Kckz,Tkzh,Ckzh,Yte,Ytm,F );

  /*Evaluate bottom and top plate resistivities*/
  Do_res(Box->Bot.rdc,Box->Bot.rrf,F,&Rb,&Xb);
  Do_res(Box->Top.rdc,Box->Top.rrf,F,&Rt,&Xt);
  Xb += Box->Bot.xdc;
  Xt += Box->Top.xdc;

  /*Evaluate Zhat*/
  Load_yhat( Tkzh,Ckzh,Yte,Box->Lossless,Rb,Rt,Xb,Xt,Znhat[0],Lay[0] );  Mat_close(Yte);
  Load_yhat( Tkzh,Ckzh,Ytm,Box->Lossless,Rb,Rt,Xb,Xt,Znhat[1],Lay[1] );  Mat_close(Ytm);
  Mat_close(Tkzh);  Mat_close(Ckzh);

  if (Box->rm_reson)  /* = 1, find resonances; = 2, remove them*/
  { mlim = nlim = (Box->Xsym) ? -1 : 0;
    for (i=0; i<=Box->Num_levels; i++)
    { /*ck how many m modes might form resonances, Kckz stores Kz**2*/
      for (j=mlim+1; j==mlim+1 && j<Box->maxm; j++)
        if ( Vec_get_re(j,Kckz->Row[i]) > 0.0 ) mlim++;
      /*ck how many n modes might form resonances*/
      for (j=nlim+1; j==nlim+1 && j<Box->maxn; j++)
        if ( Vec_get_re(j*Box->maxm,Kckz->Row[i]) > 0.0 ) nlim++;
    }
    if ( !Box->Xsym && mlim==0 )
      mlim = -1;
    if ( !Box->Xsym && nlim==0 )
      nlim = -1;
    if ( mlim>=0 || nlim>=0 )
    { ck_reson(Box->te_res,Box,mlim,nlim,Znhat[0]);
      ck_reson(Box->tm_res,Box,mlim,nlim,Znhat[1]);
    }
  }

  /*One for each layer, not level, used only with via to via coupling*/
  if (cir->vias->n) for (i=0; i<Nlay; i++)
    Vec_sdiv(0.0,*(Box->H+i)*PI*8000000.0*F*(*(Box->Mu+i))/(Box->A*Box->B),Kckz->Row[i],Znhat[2]->Row[i]);

  /* Kckz contains Kz**2, change to Kc**2 / Kz**2 */
  for (i=0; i<Nlay; i++)
    Vec_div(kc2,Kckz->Row[i],Kckz->Row[i]);

  Vec_sdiv(4.0/(Box->A*Box->B),0.0,kc2,kc2);

  for (i=0; i<Nlay+1; i++)  /*Normalize and invert Yhat (stored in Znhat)*/
  { Vec_div(kc2,Znhat[0]->Row[i],Znhat[0]->Row[i]);  /*Zte_hat*/
    Vec_div(kc2,Znhat[1]->Row[i],Znhat[1]->Row[i]);  /*Ztm_hat*/
  }

  Vec_close(kc2);
} /*Load_znhat*/

#define SIGMA_LIMIT 1.5

ck_reson(res,Box,mlim,nlim,Yhat)  int res[2*NUM_RES],mlim,nlim;  Box_info *Box;  Mat_ptr Yhat;
/*************************************************************/
/* Remove and record any box resonances.                     */
/* (C) COPYRIGHT 1986 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/*jcr17may91*/
{ int i,ilev,ires,index,idiag,idiag_lim;
  Vec_ptr yvec;
  Rtyp p0,p1,ave,sigma,limit;
  int imaxm,imaxn,mode,xsym;

  imaxm = Box->maxm;
  imaxn = Box->maxn;
  mode = Box->rm_reson;
  xsym = Box->Xsym;

  /*Clear out resonance storage*/
  for (i=0; i<2*NUM_RES; i++) res[i] = 0;
  ires = 0;

  /*Go to the central level to look for resonances*/
  i = ( Yhat->Num_row ) >> 1;
  yvec = Yhat->Row[i];

  idiag_lim = (imaxm>imaxn) ? imaxn-3 : imaxm-3;
  for (idiag=0; idiag<idiag_lim; idiag++)
  { index = imaxm * idiag + idiag;  /*diagonal element*/
    /*work on constant n paths*/
    if ( idiag<=mlim && get_stats(yvec->Im+index,1,imaxm-idiag,&ave,&sigma) )
    { i = mlim;
      /*Now search for yhats more than SIGMA_LIMIT sigma below ave*/
      limit = ave - SIGMA_LIMIT * sigma;
      while(i>=idiag && i>=(!xsym))
      /*If a mode has any significant real part, probably not a resonance*/
      { p0 = fabs(Vec_get_im(index+i-idiag,yvec));
        p1 = fabs(Vec_get_re(index+i-idiag,yvec));
        if (p1>p0) p0 = p1;
        if (p0<TINY || log(p0)<limit)
        { if (ires<NUM_RES)  /*Add resonance to list*/
          { res[3*ires] = i;
            res[3*ires+1] = idiag;
	    if (p0>TINY)
	      res[3*ires+2] = (int) (10.0 * ( limit - log(p0) ));
	    else
	      res[3*ires+2] = 100;
            ires++;
          }
          if  (mode==2) for (ilev=1; ilev<Yhat->Num_row-1; ilev++)  /*Actually remove it*/
            if ( get_stats(Yhat->Row[ilev]->Im+index,1,imaxm-idiag,&ave,&sigma) )
            { p0 = Mat_get_im(ilev,index+i-idiag,Yhat);
              if (p0 < 0.0)
		ave = -ave;
              if ( fabs(p0)<fabs(ave) )
		Mat_put_im(ilev,index+i-idiag,ave,Yhat);
            }

        } /*if p0*/
        i--;
      } /*while i*/
    } /*if get_stats*/

    /*work on the constant m paths*/
    if ( idiag<=nlim &&  get_stats(yvec->Im+index,imaxm,imaxn-idiag,&ave,&sigma) )
    { i = nlim;
      /*Now search for yhats more than SIGMA_LIMIT sigma below ave*/
      limit = ave - SIGMA_LIMIT * sigma;
      while(i>idiag && i>0)
      { p0 = fabs(Vec_get_im(index+(i-idiag)*imaxm,yvec));
        p1 = fabs(Vec_get_re(index+(i-idiag)*imaxm,yvec));
        if (p1>p0) p0 = p1;
        if (p0<TINY || log(p0)<limit)
        { if (ires<NUM_RES)
          { res[3*ires] = idiag;
            res[3*ires+1] = i;
	    res[3*ires+2] = 100;
	    if (p0>TINY) res[3*ires+2] = (int) (10.0 * ( limit - log(p0) ));
	    else res[3*ires+2] = 100;
            ires++;
          }
          if (mode==2) for (ilev=1; ilev<Yhat->Num_row-1; ilev++)
            if ( get_stats(Yhat->Row[ilev]->Im+index,imaxm,imaxn-idiag,&ave,&sigma) )
            { p0 = Mat_get_im(ilev,index+(i-idiag)*imaxm,Yhat);
              if (p0 < 0.0) ave = -ave;
              if ( fabs(p0)<fabs(ave) ) Mat_put_im(ilev,index+(i-idiag)*imaxm,ave,Yhat);
            }
        } /*if p0*/
        i--;
      } /*while i*/
    } /*if get_stats*/
  } /*for idiag*/

  if (xsym) /*Modify n mode numbers*/
    for (i=0; i<ires; i++)
      res[2*i+1] = 2 * res[2*i+1] + 1;

} /*ck_reson*/

get_stats(yvec,inc,n,avep,sigmap)  Rtyp *yvec,*avep,*sigmap;  int inc,n;
/*************************************************************/
/* Get statistics on log(*yvec).                             */
/* (C) COPYRIGHT 1986 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/*jcr21may91*/
{ Rtyp sum1,sum2,p0;
  int i,index,nsum,sign;

  sum2 = sum1 = 0.0;
  nsum = 0;
  for (i=n-1; i>=0; i--)
  { index = i * inc;
    p0 = *(yvec+index);
    if (i==n-1) sign = (p0>0.0);
    if (sign != (p0>0.0)) break;  /*chs, stop accumulating stats*/
    p0 = fabs(p0);
    if (p0<TINY) break;
    p0 = log(p0);
    nsum += (n-i+1);
    sum1 += (n-i+1) * p0;  /*Lower indices have more weight*/
    sum2 += (n-i+1) * p0 * p0;
  }

  if (nsum<=1) return(0);  /*No data*/

  *avep = sum1 / nsum;
  *sigmap = sqrt( (sum2/(nsum-1)) - *avep * *avep );
  return(1);
} /*get_stats*/

Load_kz(Box,kc2,kz2,Tkzh,Ckzh,Yte,Ytm,F)  Box_info *Box;  Vec_ptr kc2;
                               Mat_ptr kz2,Tkzh,Ckzh,Yte,Ytm;  Rtyp F;
/*************************************************************/
/* Calculate the tangent & cosine of Kz*h for each mode,layer*/
/* (C) COPYRIGHT 1986 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/*jcr21jun87*/
{ Vec_ptr Kz;
  Rtyp W,Ko,Kx2,Ky2,pioa,piob;
  Rtyp v1,v2,dv;
  Rtyp *H,*E,*M,*EL,*ML;
  int i,Im,Jn;

  W = TWO_PI*F*1000000.0;
  pioa = PI / Box->A;
  piob = PI / Box->B;

  /*Calculate Kc*/
  for (i=0,Jn=0; Jn<Box->maxn; Jn++) if (Jn%2 || !Box->Xsym )  /*exclude n even if sym*/ 
  { Ky2 = Jn*piob;  Ky2 *= Ky2;
    for (Im=0; Im<Box->maxm; Im++) 
    { Kx2 = Im*pioa;  Kx2 *= Kx2;
      Vec_put_re( i++,Kx2+Ky2,kc2 );
    }
  }
  /*Add in the interp values*/
  if (Box->num_zterp>2)
  { v1 = 1.0/Box->kc_min;  v2 = 1.0/Box->kc_max;  dv = (v2-v1)/( (Rtyp)(Box->num_zterp-1) );
    Im = kc2->Length - Box->num_zterp;
    for (i=0; i<Box->num_zterp; i++,v1 += dv)
      Vec_put_re(i+Im,1.0/(v1*v1),kc2);
  }

  Kz = Vec_open( Tkzh->Num_col );
  for (i=0,H=Box->H,E=Box->Eps,M=Box->Mu,EL=Box->Eloss,ML=Box->Mloss; i<=Box->Num_levels; i++,H++,E++,M++,EL++,ML++)
  { Ko = W*W*( *M * *E );
    Vec_ssub( Ko*(1-(*EL)*(*ML)),-Ko*((*EL)+(*ML)), kc2, kz2->Row[i] );
    Vec_sqrt( kz2->Row[i],Kz );  /*Calculation on Kz is complete*/
    /*Use Ko as temp for complex w*mu calc.*/
    Ko = W * (*M) * (1.0 + (*ML)*(*ML));
    Vec_smult( (*ML)/Ko,-1.0/Ko,Kz,Yte->Row[i]);
    Vec_sdiv( -W*(*E)*(*EL),-W*(*E),Kz,Ytm->Row[i]);
    Vec_smult( *H,0.0, Kz,Kz );
    Vec_tan( Kz,Tkzh->Row[i] );
    Vec_cos( Kz,Ckzh->Row[i] );
  }

/*xxxxx*/ /*mat_output(Tkzh);*/

  Vec_close(Kz);
} /*Load_kz*/
    
Load_yhat(Tkzh,Ckzh,Y,Lossless,Rbot,Rtop,Xbot,Xtop,Yhat,Lay)
                 Rtyp Rbot,Rtop,Xbot,Xtop;  Mat_ptr Tkzh,Ckzh,Y,Yhat,Lay;
                 int Lossless; /*Dielectric*/
/*************************************************************/
/* Yhat and Lay (layer to layer coupling)                    */
/* (C) COPYRIGHT 1986 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr15jun88 */
/* jcr15feb90 Modified to get additional data for vias */
{ int i,nz;
  Vec_ptr ut,temp;
  Mat_ptr ub;  /*Will calc. all ub's then ut's one at a time*/
  Rtyp norm;

  nz = Yhat->Num_row;
  /*Do the first ub*/
  ub = Mat_open( nz,Yhat->Num_col );

  if ( Rbot>1.0e10 ) Rbot = 1.0e10;
  if ( Xbot>1.0e10 ) Xbot = 1.0e10;
  /*Add in fudge so vias will work*/
  if ( hypot(Rbot,Xbot)<1.0e-5 ) Xbot = 1.0e-5;
  norm = Rbot*Rbot + Xbot*Xbot;
  Rbot /= norm;  Xbot /= -norm;  /*Rbot, Xbot is now admittance*/
  if ( Rbot<1.0e-10 ) Rbot = 0.0;

  if ( Rtop>1.0e10 ) Rtop = 1.0e10;
  if ( Xtop>1.0e10 ) Xtop = 1.0e10;
  /*Add in fudge so top looks same as bottom*/
  if ( hypot(Rtop,Xtop)<1.0e-5 ) Xtop = 1.0e-5;
  norm = Rtop*Rtop + Xtop*Xtop;
  Rtop /= norm;  Xtop /= -norm;  /*Rbot, Xbot is now admittance*/
  if ( Rtop<1.0e-10 ) Rtop = 0.0;

  /*Do first ub, Rbot and Xbot were chngd to addmittance*/
  Vec_init(Rbot,Xbot,ub->Row[nz-1]);

  /*Do the rest of the ub*/
  for (i=nz-2; i>=0; i--)
  { /*Calc. numerator, Lay is used as temp*/
    Vec_mult( Y->Row[i],Tkzh->Row[i],Lay->Row[0] );
    if (Lossless) Vec_init_re(0.0,Lay->Row[0]);
    Vec_sub( ub->Row[i+1],Lay->Row[0],Lay->Row[0] );
    /*Do denominator*/
    Vec_div( Tkzh->Row[i],Y->Row[i],ub->Row[i] );
    if (Lossless) Vec_init_re(0.0,ub->Row[i]);
    Vec_mult( ub->Row[i],ub->Row[i+1],ub->Row[i] );
    Vec_sadd( 1.0,0.0,ub->Row[i],ub->Row[i] );
    Vec_div( Lay->Row[0],ub->Row[i],ub->Row[i] );
  }

  /*Do first ut, Rtop,Xtop were chngd to addmittance*/
  ut = Vec_open( Yhat->Num_col );
  Vec_init(Rtop,Xtop,ut);
  Vec_add(ub->Row[0],ut,Yhat->Row[0]);  /*Yhat for top cover*/

  /*Do each Yhat and ut one at a time*/
  temp = Vec_open( Yhat->Num_col );
  for (i=1; i<nz; i++)
  { /*Calc. numerator*/
    Vec_mult( Y->Row[i-1],Tkzh->Row[i-1],temp );
    if (Lossless) Vec_init_re(0.0,temp);
    Vec_sub( ut,temp,temp );
    /*Do denominator, Lay returns the denom to main*/
    Vec_div( Tkzh->Row[i-1],Y->Row[i-1],Lay->Row[i-1] );
    if (Lossless) Vec_init_re(0.0,Lay->Row[i-1]);
    Vec_mult( Lay->Row[i-1],ut,Lay->Row[i-1] );
    Vec_sadd( 1.0,0.0,Lay->Row[i-1],Lay->Row[i-1] );
    Vec_div( temp,Lay->Row[i-1],ut );
    /*Do Yhat*/
    Vec_add( ut,ub->Row[i],Yhat->Row[i] );
    /*Finish up Lay*/
    if (Lossless) Vec_init_im(0.0,Ckzh->Row[i-1]);
    Vec_mult( Lay->Row[i-1],Ckzh->Row[i-1],Lay->Row[i-1] );
    Vec_sdiv( 1.0,0.0,Lay->Row[i-1],Lay->Row[i-1] );
  }

  Mat_close(ub);  Vec_close(ut);  Vec_close(temp);
} /*Load_yhat*/

void ff(m,n)  int m,n;
/*************************************************************/
/* Calculate ff for any subsection coupling.                 */
/* (C) COPYRIGHT 1988 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr22sep88 */ 
{ Rtyp  kx,ky,kx_sqr,ky_sqr,kc,kc_sqr;
  Rtyp Zte,Ztm;
  Rtyp Gxx,Gxy,Gyx,Gyy;
  int loc;

  /*Calculate mode specific constants.*/
  kx = m*Piova;  ky = n*Piovb;
  kx_sqr = kx*kx;  ky_sqr = ky*ky;

  if (m<maxm && n<maxn)
  { loc = m + ( n>>xsym ) * maxm;
    Zte = *(Zte_vec_im + loc);  Ztm = *(Ztm_vec_im + loc);
  }
  else
  { kc_sqr = kx_sqr + ky_sqr;
    kc = sqrt(kc_sqr);
    loc = (int)( terp_a + terp_b/kc );
    Ztm = *(tm_im_a0+loc) + kc_sqr * ( *(tm_im_a1+loc) + kc_sqr * ( *(tm_im_a2+loc) +
                            kc_sqr * *(tm_im_a3+loc) ) );
    Zte = *(te_im_a0+loc) + ( *(te_im_a1+loc) + ( *(te_im_a2+loc) +  
                            *(te_im_a3+loc)/kc_sqr )/kc_sqr )/kc_sqr;
  }

  ff_im = 0.0;
  /*Do coupling from x to x directed current*/
  if (fsx && ffx)
  { if (fsx==ffx) { Gxx = (*fsx)(kx,ky,dxps);  Gxx *= Gxx; }
    else { Gxx = (*fsx)(kx,ky,dxps) * (*ffx)(kx,ky,dxpf); }
    if (m==0 || n==0) Gxx *= 0.5;  /* N1*N1, N2*N2 are halved if m*n==0 */
    ff_im = - Gxx * (ky_sqr*Zte + kx_sqr*Ztm);
  }

  /*Do coupling from y to y directed current*/
  if (fsy && ffy)
  { if (fsy==ffy) { Gyy = (*fsy)(ky,kx,dyps);  Gyy *= Gyy; }
    else { Gyy = (*fsy)(ky,kx,dyps) * (*ffy)(ky,kx,dypf); }
    if (m==0 || n==0) Gyy *= 0.5;
    ff_im += - Gyy * (ky_sqr*Ztm + kx_sqr*Zte);
  }

  /*Do coupling from x to y directed current*/
  if (fsx && ffy)
  { Gxy = (*fsx)(kx,ky,dxps) * (*ffy)(ky,kx,dypf) * kx * ky;
    ff_im += Gxy * (Zte - Ztm);
  }

  /*Do coupling from y to x directed current*/
  if (fsy && ffx)
  { Gyx = (*fsy)(ky,kx,dyps) * (*ffx)(kx,ky,dxpf) * kx * ky;
    ff_im += Gyx * (Zte - Ztm);
  }

  ff_re = 0.0;  /*Do real part if needed*/
  if (!loss) return;
  if (m<maxm && n<maxn)
  { Zte = *(Zte_vec_re + loc);  Ztm = *(Ztm_vec_re + loc); }
  else
  { Ztm = *(tm_re_a0+loc) + kc_sqr * ( *(tm_re_a1+loc) + kc_sqr * ( *(tm_re_a2+loc) +
                            kc_sqr * *(tm_re_a3+loc) ) );
    Zte = *(te_re_a0+loc) + ( *(te_re_a1+loc) + ( *(te_re_a2+loc) +
                            *(te_re_a3+loc)/kc_sqr )/kc_sqr )/kc_sqr;
  }

  /*Do coupling from x to x directed current*/
  if (fsx && ffx) ff_re = - Gxx * (ky_sqr*Zte + kx_sqr*Ztm);

  /*Do coupling from y to y directed current*/
  if (fsy && ffy) ff_re += - Gyy * (ky_sqr*Ztm + kx_sqr*Zte);

  /*Do coupling from x to y directed current*/
  if (fsx && ffy) ff_re += Gxy * (Zte - Ztm);

  /*Do coupling from y to x directed current*/
  if (fsy && ffx) ff_re += Gyx * (Zte - Ztm);

} /*ff*/

void ffxz(m,n)  int m,n;
/*************************************************************/
/* Calculate ff for any subsection to via coupling.          */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr20feb90 */ 
{ Rtyp kx,ky,kc,kc_sqr;
  Rtyp Ztm,Gxz,Gyz;
  int loc;

  /*Calculate mode specific constants.*/
  kx = m*Piova;  ky = n*Piovb;

  if (m<maxm && n<maxn)
  { loc = m + ( n>>xsym ) * maxm;
    Ztm = *(Ztm_vec_im + loc);
  }
  else
  { kc_sqr = kx * kx + ky * ky;
    kc = sqrt(kc_sqr);
    loc = (int)( terp_a + terp_b/kc );
    Ztm = *(tm_im_a0+loc) + kc_sqr * ( *(tm_im_a1+loc) + kc_sqr * ( *(tm_im_a2+loc) +
                            kc_sqr * *(tm_im_a3+loc) ) );
  }

  ff_im = 0.0;
  /*Do coupling from x to z directed current*/
  if (fsx && ffz)
  { Gxz = kx * (*fsx)(kx,ky,dxps) * (*ffz)(kx,ky,dzpf);
    ff_im = Gxz * Ztm;
  }

  /*Do coupling from y to z directed current*/
  if (fsy && ffz)
  { Gyz = ky * (*fsy)(ky,kx,dyps) * (*ffz)(kx,ky,dzpf);
    ff_im += Gyz * Ztm;
  }
  /*Do coupling from z to x directed current*/
  if (fsz && ffx)
  { Gxz = kx * (*fsz)(kx,ky,dzps) * (*ffx)(kx,ky,dxpf);
    ff_im += Gxz * Ztm;
  }

  /*Do coupling from z to y directed current*/
  if (fsz && ffy)
  { Gyz = ky * (*fsz)(kx,ky,dzps) * (*ffy)(ky,kx,dypf);
    ff_im += Gyz * Ztm;
  }

  ff_re = 0.0;  /*Do real part if needed*/
  if (!loss) return;
 
  if (m<maxm && n<maxn)  Ztm = *(Ztm_vec_re + loc);
  else  Ztm = *(tm_re_a0+loc) + kc_sqr * ( *(tm_re_a1+loc) + kc_sqr * ( *(tm_re_a2+loc) +
                            kc_sqr * *(tm_re_a3+loc) ) );

  /*Do coupling from x to z directed current*/
  if (fsx && ffz) ff_re = Gxz * Ztm;

  /*Do coupling from y to z directed current*/
  if (fsy && ffz) ff_re += Gyz * Ztm;

  /*Do coupling from z to x directed current*/
  if (fsz && ffx) ff_re += Gxz * Ztm;

  /*Do coupling from z to y directed current*/
  if (fsz && ffy) ff_re += Gyz * Ztm;

} /*ffxz*/

void ffzz(m,n)  int m,n;
/*************************************************************/
/* Calculate ff for any via to via coupling.                 */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr20feb90 */ 
{ Rtyp kx,ky,kc,kc_sqr;
  Rtyp Ztm,Gzz;
  int loc;

  kx = m*Piova;  ky = n*Piovb;
  if (m<maxm && n<maxn)
  { loc = m + ( n>>xsym ) * maxm;
    Ztm = *(Ztm_vec_im + loc);
  }
  else
  { kc_sqr = kx * kx + ky * ky;
    kc = sqrt(kc_sqr);
    loc = (int)( terp_a + terp_b/kc );
    Ztm = *(tm_im_a0+loc) + kc_sqr * ( *(tm_im_a1+loc) + kc_sqr * ( *(tm_im_a2+loc) +
                            kc_sqr * *(tm_im_a3+loc) ) );
  }

  ff_im = 0.0;
  /*Do coupling from z to z directed current*/
  Gzz = (*fsz)(kx,ky,dzps) * (*ffz)(kx,ky,dzpf);
  ff_im = Gzz * Ztm;

  ff_re = 0.0;  /*Do real part if needed*/
  if (!loss) return;
 
  if (m<maxm && n<maxn)  Ztm = *(Ztm_vec_re + loc);
  else  Ztm = *(tm_re_a0+loc) + kc_sqr * ( *(tm_re_a1+loc) + kc_sqr * ( *(tm_re_a2+loc) +
                            kc_sqr * *(tm_re_a3+loc) ) );

  ff_re = Gzz * Ztm;

} /*ffzz*/

init_ztm_interp(ztm,a0p,a1p,a2p,a3p)  Rtyp *ztm;  Rtyp **a0p,**a1p,**a2p,**a3p;
/*************************************************************/
/* Set up the interpolation vectors.                         */
/* (C) COPYRIGHT 1988 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr08feb89 */ 
/* nterp, kc_min and kc_max (global vars) should already be set up*/
{ Rtyp *a0,*a1,*a2,*a3;
  Rtyp v1,v2,dv,x0,x1,x2,x3;
  int i;

  /*Allocate the vectors*/
  if (*a0p!=NULL) sFree( (char *)*a0p);  *a0p = (Rtyp *)new( 4*nterp*sizeof(Rtyp) );
  a0 = *a0p;  a1 = *a1p = a0 + nterp;  a2 = *a2p = a1 + nterp;  a3 = *a3p = a2 + nterp;
  
  /*Fill up the arrays*/
  v2 = 1.0/kc_max;  v1 = 1.0/kc_min;  dv = (v2-v1) / ( (Rtyp)(2+nterp) );
  for (i=0; i<nterp; i++)
  { x0 = 1.0/v1;  x1 = 1.0/(v1 += dv);  x2 = 1.0/(v1 + dv);  x3 = 1.0/(v1+2.0*dv);
    x0 *= x0;  x1 *= x1;  x2 *= x2;  x3 *= x3;
    *a0 = *ztm;
    *a1 = ( *(ztm+1) - *a0 ) / (x1-x0);
    *a2 = ( *(ztm+2) - *(ztm+1) ) / (x2-x1) - *a1;
    *a2 /= (x2-x0);
    *a3 = ( *(ztm+3) - *(ztm+2) ) / (x3-x2) - ( *(ztm+2) - *(ztm+1) ) / (x2-x1);
    *a3 /= (x3-x1);
    *a3 = (*a3 - *a2) / (x3-x0);
    *a2 -= (x2+x1+x0) * *a3;
    *a1 -= (x1+x0) * *a2;
    *a1 -= (x1*x1+x1*x0+x0*x0) * *a3;
    *a0 -= ( x0 * ( *a1 + x0 * ( *a2 + x0 * *a3 ) ) );
    a0++;  a1++;  a2++;  a3++;
    ztm++;
  }
} /*init_ztm_interp*/

init_zte_interp(zte,a0p,a1p,a2p,a3p)  Rtyp *zte;  Rtyp **a0p,**a1p,**a2p,**a3p;
/*************************************************************/
/* Set up the interpolation vectors.                         */
/* (C) COPYRIGHT 1988 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr09feb89 */ 
/* nterp,kc_min,kc_max (global vars) should already be set up*/
{ Rtyp *a0,*a1,*a2,*a3;
  Rtyp v0,v2,dv,x0,x1,x2,x3;
  int i;

  /*Allocate the vectors*/
  if (*a0p!=NULL) sFree( (char *)*a0p);  *a0p = (Rtyp *)new( 4*nterp*sizeof(Rtyp) );
  a0 = *a0p;  a1 = *a1p = a0 + nterp;  a2 = *a2p = a1 + nterp;  a3 = *a3p = a2 + nterp;
  
  /*Fill up the arrays*/
  v2 = 1.0/kc_max;  v0 = 1.0/kc_min;  dv = (v2-v0) / ( (Rtyp)(2+nterp) );
  for (i=0; i<nterp; i++)
  { x0 = v0; x1 = v0 = x0 + dv;  x2 = x1 + dv;  x3 = x2 + dv;
    x0 *= x0;  x1 *= x1;  x2 *= x2;  x3 *= x3;
    *a0 = *zte;
    *a1 = ( *(zte+1) - *a0 ) / (x1-x0);
    *a2 = ( *(zte+2) - *(zte+1) ) / (x2-x1) - *a1;
    *a2 /= (x2-x0);
    *a3 = ( *(zte+3) - *(zte+2) ) / (x3-x2) - ( *(zte+2) - *(zte+1) ) / (x2-x1);
    *a3 /= (x3-x1);
    *a3 = (*a3 - *a2) / (x3-x0);
    *a2 -= (x2+x1+x0) * *a3;
    *a1 -= (x1+x0) * *a2;
    *a1 -= (x1*x1+x1*x0+x0*x0) * *a3;
    *a0 -= ( x0 * ( *a1 + x0 * ( *a2 + x0 * *a3 ) ) );
    a0++;  a1++;  a2++;  a3++;
    zte++;
  }
} /*init_zte_interp*/

Rtyp Groof(kx,ky,dp)  Rtyp kx,ky,*dp; 
/*************************************************************/
/* Calculate G for an x directed rooftop.                    */
/* (C) COPYRIGHT 1988 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr02nov88 */ 
/* *dp = dx, *(dp+1) = dy, roof is 4dx x 2dy */
/* reverse above for y directed*/
{ Rtyp G,dxkx;

  /*do triangle*/
  if (kx<TINY) G = 2.0*(*dp);
  else { dxkx = *dp * kx;
	 G = (1.0 - cos(2.0*dxkx))/(dxkx*kx);
       }

  /*do rectangle*/
  dp++;
  if (ky<TINY) G *=  2.0*(*dp);
  else G *= 2.0*sin(ky*(*dp))/ky;
  return(G);
} /*Groof*/

Rtyp Garoof(kx,ky,dp)  Rtyp kx,ky,*dp; 
/*************************************************************/
/* Calculate G for an x directed anti-symmetric rooftop.     */
/* (C) COPYRIGHT 1988 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr02nov88 */ 
/* *dp = dx, *(dp+1) = dy, roof is 4dx x 2dy */
/* reverse above for y directed*/
{ Rtyp G,dxkx;

  /*do antisymmetric rooftop*/
  if (kx<TINY) G = 0.0;
  else { dxkx = *dp * kx;
         G = (2.0 - sin(2.0*dxkx)/dxkx) / kx;
       }

  /*do rectangle portion*/
  dp++;
  if (ky<TINY) G *=  2.0*(*dp);
  else G *= 2.0*sin(ky*(*dp))/ky;
  return(G);
} /*Garoof*/

Rtyp Gbow1(kx,ky,dp)  Rtyp kx,ky,*dp; 
/*************************************************************/
/* Calculate G for a vertical bow tie with x current.        */
/* (C) COPYRIGHT 1988 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr02nov88 */ 
/* *dp = dx, *(dp+1) = dy, bow tie is 2dx x 2dy */
/* *(dp+2) = norm constant */
/* reverse above for y directed horizontal bow tie*/
{ Rtyp G,kxdx,kydy;

  if (ky<=TINY) return(0.0);
  kxdx = kx * *dp;  kydy = ky * *(dp+1);
  if (kx<=TINY) G = 4.0 * *dp * cos(kydy) / ky;
  else          G = 4.0 * sin(kxdx) * cos(kydy) / (kx*ky);

  if ( fabs(1.0-kxdx/kydy)>0.0001 )
    G -= 4.0*(*dp) * (kxdx*sin(kxdx)*cos(kydy)-kydy*cos(kxdx)*sin(kydy))
					      / (ky*(kxdx*kxdx-kydy*kydy));
  else
    G -= sin(2.0*kxdx)/(kx*ky) + 2.0 * *dp / ky;

  G *= *(dp+2);
  return(G);
} /*Gbow1*/

Rtyp Gbow2(kx,ky,dp)  Rtyp kx,ky,*dp; 
/*************************************************************/
/* Calculate G for a horizontal bow tie with x current.      */
/* (C) COPYRIGHT 1988 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr02nov88 */ 
/* *dp = dx, *(dp+1) = dy, bow tie is 2dx x 2dy */
/* *(dp+2) = norm constant. */
/* reverse above for y directed vertical bow tie*/
/* bow tie is anti-symm, with ramps in and out*/
{ Rtyp G,Gr,AA,BB,kxdx,kydy;

  if (ky<=TINY) return(0.0);

  kxdx = kx * *dp;  kydy =  ky * *(dp+1);
  if ( fabs(1.0-kxdx/kydy)>0.0001 )
    G = - 4.0*(*dp) * (kxdx*cos(kxdx)*sin(kydy)-kydy*sin(kxdx)*cos(kydy))
					      / (ky*(kxdx*kxdx-kydy*kydy));
  else
    G = - sin(2.0*kxdx)/(kx*ky) + 2.0 * *dp / ky;

  /*Add ramp in and out, Ky==0 has already been filtered out*/
  if (kx>TINY)
  { AA = (1.0 - cos(2.0*kxdx))/(kxdx*kx);  /*Actually 2A and 2B*/
    BB = (sin(2.0*kxdx)/kxdx - 2.0) / kx;
    Gr = AA*sin(kxdx) - BB*cos(kxdx);
    Gr *= 2.0*sin(kydy)/ky;  /*rectangle*/
    G += Gr;
  }

  G *= *(dp+2);
  return(G);
} /*Gbow2*/

Rtyp Grr(kx,ky,dp)  Rtyp kx,ky,*dp; 
/*************************************************************/
/* Calculate G for a rectangular pulse (in x AND y).         */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr19feb90 */ 
{ if (kx<TINY) return( 2.0*(*dp) );
  if (ky<TINY) return( 2.0*(*(dp+1)) );
  return( 4.0*sin(kx*(*dp))*sin(ky*(*(dp+1)))/(kx*ky) );
} /*Grr*/

init_sub_typ(Box) Box_info *Box;
/*************************************************************/
/* Initialize default subsection types.                      */
/* (C) COPYRIGHT 1988 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr04nov88 */ 
{ add_sub_typ(RFX,Box);
  add_sub_typ(RFY,Box);
  add_sub_typ(ARFX,Box);
  add_sub_typ(ARFY,Box);
  add_sub_typ(LOOP,Box);
  add_sub_typ(CROSS,Box);
  add_sub_typ(VIA,Box);
  init_ej(Box);
} /*init_sub_typ*/

update_sub_typ(is,Box)  sub_typ *is; Box_info *Box;
/*************************************************************/
/* Set all parameters (except id) for the isub-th sub_typ.   */
/* (C) COPYRIGHT 1988 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr03nov88 */ 
/* id is assummed set to a valid subsection type and suff. room
   is assummed already malloced to dxp and dyp */
{ Rtyp *dxp,*dyp,*dzp,dx,dy;
  int *ic;

  dxp = is->dxp;  dyp = is->dyp;  dzp = is->dzp;
  dx = Box->A / Box->Capm;
  dy = Box->B / Box->Capn;

  is->fx = is->fy = is->fz = NULL;

  switch (is->id)
  { case RFX   : is->fx = Groof;
		 *dxp = dx;  *(dxp+1) = dy;
                 is->weight = 0.5/dy;  /*Divide current density by to get current*/
		 is->cosm = 1;  is->cosn = 0;  is->modd = 0;  is->nodd = 1;
		 is->num_sqr = 2;  ic = is->sqr_coord;
		 *ic    = -1;  *(ic+1) = 0;
		 *(ic+2) = 1;  *(ic+3) = 0;
		 break;
    case RFY   : is->fy = Groof;  
		 *dyp = dy;  *(dyp+1) = dx;  is->weight = 0.5/dx;
		 is->cosm = 0;  is->cosn = 1;  is->modd = 1;  is->nodd = 0;
		 is->num_sqr = 2;  ic = is->sqr_coord;
		 *ic     = 0;  *(ic+1) = -1;
		 *(ic+2) = 0;  *(ic+3) = 1;
		 break;
    case ARFX  : is->fx = Garoof;
		 *dxp = dx;  *(dxp+1) = dy;  is->weight = 0.5/dy;
		 is->cosm = 0;  is->cosn = 0;  is->modd = 0;  is->nodd = 1;
		 is->num_sqr = 2;  ic = is->sqr_coord;
		 *ic    = -1;  *(ic+1) = 0;
		 *(ic+2) = 1;  *(ic+3) = 0;
		 break;
    case ARFY  : is->fy = Garoof;  
		 *dyp = dy;  *(dyp+1) = dx;  is->weight = 0.5/dx;
		 is->cosm = 0;  is->cosn = 0;  is->modd = 1;  is->nodd = 0;
		 is->num_sqr = 2;  ic = is->sqr_coord;
		 *ic     = 0;  *(ic+1) = -1;
		 *(ic+2) = 0;  *(ic+3) = 1;
		 break;
    case LOOP  : is->fx = Gbow1;  is->fy = Gbow1;  
		 *dxp = dx;  *(dxp+1) = dy;  *(dxp+2) = 1.0;
		 *dyp = dy;  *(dyp+1) = dx;  *(dyp+2) = -dy/dx;  is->weight = 0.5/dy;
		 is->cosm = 1;  is->cosn = 1;  is->modd = 1;  is->nodd = 1;
		 is->num_sqr = 1;  ic = is->sqr_coord;
		 *ic     = 0;  *(ic+1) = 0;
		 break;
    case CROSS : is->fx = Gbow2;  is->fy = Gbow2;
		 *dxp = dx;  *(dxp+1) = dy;  *(dxp+2) = 1.0;
		 *dyp = dy;  *(dyp+1) = dx;  *(dyp+2) = -dy/dx;  is->weight = 0.5/dy;
		 is->cosm = 0;  is->cosn = 0;  is->modd = 1;  is->nodd = 1;
		 is->num_sqr = 5;  ic = is->sqr_coord;
		 *ic     = 0;  *(ic+1) = 0;
		 *(ic+2) = -2; *(ic+3) = 0;
		 *(ic+4) = 2;  *(ic+5) = 0;
		 *(ic+6) = 0;  *(ic+7) = -2;
		 *(ic+8) = 0;  *(ic+9) = 2;
		 break;
    case VIA   : is->fz = Grr;
		 *dzp = dx;  *(dzp+1) = dy;  is->weight = 0.25/(dx*dy);
		 is->cosm = 0;  is->cosn = 0;  is->modd = 1;  is->nodd = 1;
		 is->num_sqr = 1;  ic = is->sqr_coord;
		 *ic    = 0;  *(ic+1) = 0;
		 break;
  }

} /*update_sub_typ*/

add_sub_typ(ityp,Box)  int ityp;  Box_info *Box;
/*************************************************************/
/* Add a subsection type.                                    */
/* (C) COPYRIGHT 1988 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr04nov88 */ 
{ sub_typ *isub;
  if (Box->sub==NULL) Box->sub = (sub_typ *)new(NUM_ESUB*sizeof(sub_typ));
  isub = Box->sub+ityp;
  isub->dxp = (Rtyp *)new(MAXDXP*sizeof(Rtyp));
  isub->dyp = (Rtyp *)new(MAXDYP*sizeof(Rtyp));
  isub->dzp = (Rtyp *)new(MAXDZP*sizeof(Rtyp));
  isub->id = ityp;
  isub->sqr_coord = (int *)new(2*MAXSQR*sizeof(int));
  isub->ej_loc = (int *)cnew(MAXSQR,sizeof(int));
  update_sub_typ(isub,Box);
} /*add_sub_typ*/

clean_sub(sub)  sub_typ *sub;
/*************************************************************/
/* Remove all memory allocated in sub.                       */
/* (C) COPYRIGHT 1988 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr09oct88 */ 
{ if (sub->dxp!=NULL) sFree( (char *)sub->dxp);  sub->dxp = NULL;
  if (sub->dyp!=NULL) sFree( (char *)sub->dyp);  sub->dyp = NULL;
  if (sub->dzp!=NULL) sFree( (char *)sub->dzp);  sub->dzp = NULL;
  sub->num_sqr = 0;
  if (sub->sqr_coord!=NULL) sFree( (char *)sub->sqr_coord);  sub->sqr_coord = NULL;
  if (sub->ej_loc!=NULL) sFree( (char *)sub->ej_loc);  sub->ej_loc = NULL;
} /*clean_sub*/

#define XUPPOS 0
#define XDNPOS 1
#define XUPNEG 2
#define XDNNEG 3
#define YUPPOS 4
#define YDNPOS 5
#define YUPNEG 6
#define YDNNEG 7
#define LP_CEN 8
#define CRS_CEN 9
#define VIA_CEN 10

init_ej(Box)  Box_info *Box;
/*************************************************************/
/* Initialize the e.j array for calc of loss.                */
/* (C) COPYRIGHT 1988 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr29jan89 */ 
{ int i,j,sum,isqr_id,jsqr_id;
  sub_typ *isub,*jsub;
  Rtyp area,tri_ymult;
  Rtyp *ej_ptr;

  /*If ej_loss not properly allocated, do so*/
  for (sum=0,isub=Box->sub; isub<(Box->sub+NUM_ESUB); isub++)
    for (i=0; i<isub->num_sqr; i++)  *(isub->ej_loc+i) = sum++;
  if (sum!=Box->num_ej)
  { Box->num_ej = sum;
    if (Box->ej_loss!=NULL) sFree( (char *)Box->ej_loss);
    Box->ej_loss = (Rtyp *)new( sum*sum*sizeof(Rtyp) );
  }

  /*Clear the ej_loss matrix*/
  for (i=0; i<sum*sum; i++) *(Box->ej_loss+i) = 0.0;
  /*Load the ej_loss matrix*/
  area = 4.0 * Box->A * Box->B / ( Box->Capm * Box->Capn );
  tri_ymult = Box->B * Box->Capm / ( Box->A * Box->Capn );  /* = dy/dx */
  for (isub=Box->sub; isub<(Box->sub+NUM_ESUB); isub++)
    for (jsub=Box->sub; jsub<(Box->sub+NUM_ESUB); jsub++)
      for (i=0; i<isub->num_sqr; i++) for (j=0; j<jsub->num_sqr; j++)
      { ej_ptr = Box->ej_loss + *(isub->ej_loc+i);
	ej_ptr += *(jsub->ej_loc+j) * Box->num_ej;
        isqr_id = sqr_id(isub,i);  jsqr_id = sqr_id(jsub,j);
        *ej_ptr = area * ej_calc_coef( isqr_id,jsqr_id );
	if ( isub->id==CROSS && (isqr_id == YUPNEG || isqr_id == YDNPOS) )
	  *ej_ptr *= tri_ymult;
	if ( jsub->id==CROSS && (jsqr_id == YUPNEG || jsqr_id == YDNPOS) )
	  *ej_ptr *= tri_ymult;
        if ( isqr_id == jsqr_id && (isqr_id==LP_CEN || isqr_id==CRS_CEN) )
	  *ej_ptr *= 0.5 * ( 1.0 + tri_ymult*tri_ymult );  /*Only half of CEN is reduced*/
      }
} /*init_ej*/

int sqr_id(sub,i) sub_typ *sub;  int i;
/*************************************************************/
/* Figure type of i-th sqr of sub.                           */
/* (C) COPYRIGHT 1988 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr29jan89 */ 
{ int icx,icy;

  if (i>=sub->num_sqr || i<0)
    announce_bug("sqr_id(0)");

  icx = *(sub->sqr_coord+2*i);  icy = *(sub->sqr_coord+2*i+1);
  switch(sub->id)
  { case RFX  : if (icx == -1 && icy == 0) return(XUPPOS);
		if (icx == 1 && icy == 0) return(XDNPOS);
		break;
    case RFY  : if (icx == 0 && icy == -1) return(YUPPOS);
		if (icx == 0 && icy == 1) return(YDNPOS);
		break;
    case ARFX : if (icx == -1 && icy == 0) return(XUPPOS);
		if (icx == 1 && icy == 0)  return(XDNNEG);
		break;
    case ARFY : if (icx == 0 && icy == -1) return(YUPPOS);
		if (icx == 0 && icy == 1) return(YDNNEG);
		break;
    case LOOP : if (icx == 0 && icy == 0) return(LP_CEN);
                break;
    case CROSS: if (icx == 0 && icy == 0) return(CRS_CEN);
		if (icx == -2 && icy == 0) return(XUPPOS);
		if (icx == 2 && icy == 0) return(XDNNEG);
		if (icx == 0 && icy == -2) return(YUPNEG);
		if (icx == 0 && icy == 2) return(YDNPOS);
		break;
    case VIA:   if (icx == 0 && icy == 0) return(VIA_CEN);
                break;
  }
  /*If we reach this point, we have an error.*/
  announce_bug("sqr_id(1)");
  return(0);  /*To satisfy lint*/
} /*sqr_id*/

Rtyp ej_calc_coef(isqr,jsqr)  int isqr,jsqr;
/*************************************************************/
/* Return the coefficient for multiplying resistivity.       */
/* (C) COPYRIGHT 1988 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr29jan89 */ 
{
  if (isqr==LP_CEN && jsqr==LP_CEN) return(1.0);
  if (isqr==CRS_CEN && jsqr==CRS_CEN) return(1.0);
  if (isqr==VIA_CEN && jsqr==VIA_CEN) return(1.0);

  if (isqr==XUPPOS) switch(jsqr)
  { case XUPPOS : return(1.0/3.0);
    case XDNPOS : return(1.0/6.0);
    case XUPNEG : return(-1.0/3.0);
    case XDNNEG : return(-1.0/6.0);
  }
  if (isqr==XDNPOS) switch(jsqr)
  { case XUPPOS : return(1.0/6.0);
    case XDNPOS : return(1.0/3.0);
    case XUPNEG : return(-1.0/6.0);
    case XDNNEG : return(-1.0/3.0);
  }
  if (isqr==XUPNEG) switch(jsqr)
  { case XUPPOS : return(-1.0/3.0);
    case XDNPOS : return(-1.0/6.0);
    case XUPNEG : return(1.0/3.0);
    case XDNNEG : return(1.0/6.0);
  }
  if (isqr==XDNNEG) switch(jsqr)
  { case XUPPOS : return(-1.0/6.0);
    case XDNPOS : return(-1.0/3.0);
    case XUPNEG : return(1.0/6.0);
    case XDNNEG : return(1.0/3.0);
  }
  if (isqr==YUPPOS) switch(jsqr)
  { case YUPPOS : return(1.0/3.0);
    case YDNPOS : return(1.0/6.0);
    case YUPNEG : return(-1.0/3.0);
    case YDNNEG : return(-1.0/6.0);
  }
  if (isqr==YDNPOS) switch(jsqr)
  { case YUPPOS : return(1.0/6.0);
    case YDNPOS : return(1.0/3.0);
    case YUPNEG : return(-1.0/6.0);
    case YDNNEG : return(-1.0/3.0);
  }
  if (isqr==YUPNEG) switch(jsqr)
  { case YUPPOS : return(-1.0/3.0);
    case YDNPOS : return(-1.0/6.0);
    case YUPNEG : return(1.0/3.0);
    case YDNNEG : return(1.0/6.0);
  }
  if (isqr==YDNNEG) switch(jsqr)
  { case YUPPOS : return(-1.0/6.0);
    case YDNPOS : return(-1.0/3.0);
    case YUPNEG : return(1.0/6.0);
    case YDNNEG : return(1.0/3.0);
  }
  return(0.0);
} /*ej_calc_coef*/

qreduce_h( )
/*************************************************************/
/* Calculate coupling between subsections.                   */
/* (C) COPYRIGHT 1992 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr29apr92 broken out from do_coup*/
/* jcr13jul92 modified for quad prec. option*/
{ RRtyp tmp;
  int i,j;

  /*Incorporate the h vectors and scalars into the h matrix*/
  if (qhh.gN_im)
  { for (i=0; i<qhh.n; i++)
    { tmp = *(qhh.gN_im + i) + qhh.oo_im;
      for (j=0; j<qhh.m; j++)
        *(qhh.mat_im + qhh.n * j + i) += tmp;
    }
    qhh.oo_im = 0.0;  /*Flag that qhh.oo_im has been added in*/
  }
  if (qhh.gN_re)
  { for (i=0; i<qhh.n; i++)
    { tmp = *(qhh.gN_re + i) + qhh.oo_re;
      for (j=0; j<qhh.m; j++)
        *(qhh.mat_re + qhh.n * j + i) += tmp;
    }
    qhh.oo_re = 0.0;  /*Flag that qhh.oo_re has been added in*/
  }

  if (qhh.gM_im)
    for (j=0; j<qhh.m; j++)
    { tmp = *(qhh.gM_im + j);
      for (i=0; i<qhh.n; i++)
        *(qhh.mat_im + qhh.n * j + i) += tmp;
    }
  if (qhh.gM_re)
    for (j=0; j<qhh.m; j++)
    { tmp = *(qhh.gM_re + j);
      for (i=0; i<qhh.n; i++)
        *(qhh.mat_re + qhh.n * j + i) += tmp;
    }

  if (fabs(qhh.oo_im)>TINY)
    for (i=0; i<qhh.m*qhh.n; i++)
      *(qhh.mat_im + i) = qhh.oo_im;
  if (qhh.mat_re != NULL && fabs(qhh.oo_re) > TINY)
    for (i=0; i<qhh.m*qhh.n; i++)
      *(qhh.mat_re + i) = qhh.oo_re;

  if (qhh.gNm_im)
  { for (i=0; i<qhh.n; i++)
    { tmp = *(qhh.gNm_im + i) + qhh.mo_im;
      for (j=0; j<qhh.m; j += 2)
        *(qhh.mat_im + qhh.n * j + i) += tmp;
      for (j=1; j<qhh.m; j += 2)
        *(qhh.mat_im + qhh.n * j + i) -= tmp;
    }
    qhh.mo_im = 0.0;  /*Flag that qhh.mo_im has been added in*/
  }
  if (qhh.gNm_re)
  { for (i=0; i<qhh.n; i++)
    { tmp = *(qhh.gNm_re + i) + qhh.mo_re;
      for (j=0; j<qhh.m; j += 2)
        *(qhh.mat_re + qhh.n * j + i) += tmp;
      for (j=1; j<qhh.m; j += 2)
        *(qhh.mat_re + qhh.n * j + i) -= tmp;
    }
    qhh.mo_re = 0.0;  /*Flag that qhh.mo_re has been added in*/
  }


  if (fabs(qhh.mo_im)>TINY)
    for (i=0; i<qhh.n; i++)
    { for (j=0; j<qhh.m; j += 2)
        *(qhh.mat_im + qhh.n * j + i) += qhh.mo_im;
      for (j=1; j<qhh.m; j += 2)
        *(qhh.mat_im + qhh.n * j + i) -= qhh.mo_im;
    }
  if (fabs(qhh.mo_re)>TINY)
    for (i=0; i<qhh.n; i++)
    { for (j=0; j<qhh.m; j += 2)
        *(qhh.mat_re + qhh.n * j + i) += qhh.mo_re;
      for (j=1; j<qhh.m; j += 2)
        *(qhh.mat_re + qhh.n * j + i) -= qhh.mo_re;
    }

  if (qhh.gMn_im)
  { for (j=0; j<qhh.m; j++)
    { tmp = *(qhh.gMn_im + j) + qhh.on_im;
      for (i=0; i<qhh.n; i += 2)
	*(qhh.mat_im + qhh.n * j + i) += tmp;
      for (i=1; i<qhh.n; i += 2)
	*(qhh.mat_im + qhh.n * j + i) -= tmp;
    }
    qhh.on_im = 0.0;  /*Flag that qhh.on_im has been added in*/
  }
  if (qhh.gMn_re)
  { for (j=0; j<qhh.m; j++)
    { tmp = *(qhh.gMn_re + j) + qhh.on_re;
      for (i=0; i<qhh.n; i += 2)
	*(qhh.mat_re + qhh.n * j + i) += tmp;
      for (i=1; i<qhh.n; i += 2)
	*(qhh.mat_re + qhh.n * j + i) -= tmp;
    }
    qhh.on_re = 0.0;  /*Flag that qhh.on_re has been added in*/
  }

  if (fabs(qhh.on_im)>TINY)
    for (j=0; j<qhh.m; j++)
    { for (i=0; i<qhh.n; i += 2)
	*(qhh.mat_im + qhh.n * j + i) += qhh.on_im;
      for (i=1; i<qhh.n; i += 2)
	*(qhh.mat_im + qhh.n * j + i) -= qhh.on_im;
    }
  if (fabs(qhh.on_re)>TINY && qhh.mat_re)
    for (j=0; j<qhh.m; j++)
    { for (i=0; i<qhh.n; i += 2)
	*(qhh.mat_re + qhh.n * j + i) += qhh.on_re;
      for (i=1; i<qhh.n; i += 2)
	*(qhh.mat_re + qhh.n * j + i) -= qhh.on_re;
    }

  if (fabs(qhh.mn_im)>TINY)
    for (j=0; j<qhh.m; j++)
    { tmp = (j&1) ? -qhh.mn_im : qhh.mn_im;
      for (i=0; i<qhh.n; i += 2)
	*(qhh.mat_im + qhh.n * j + i) += tmp;
      for (i=1; i<qhh.n; i += 2)
	*(qhh.mat_im + qhh.n * j + i) -= tmp;
    }
  if (fabs(qhh.mn_re)>TINY)
    for (j=0; j<qhh.m; j++)
    { tmp = (j&1) ? -qhh.mn_re : qhh.mn_re;
      for (i=0; i<qhh.n; i += 2)
	*(qhh.mat_re + qhh.n * j + i) += tmp;
      for (i=1; i<qhh.n; i += 2)
	*(qhh.mat_re + qhh.n * j + i) -= tmp;
    }

} /*qreduce_h*/

reduce_h( )
/*************************************************************/
/* Calculate coupling between subsections.                   */
/* (C) COPYRIGHT 1992 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr29apr92 broken out from do_coup*/
{ Rtyp tmp;
  int i,j;

  /*Incorporate the h vectors and scalars into the h matrix*/
  if (hh.gN_im)
  { for (i=0; i<hh.n; i++)
    { tmp = *(hh.gN_im + i) + hh.oo_im;
      for (j=0; j<hh.m; j++)
        *(hh.mat_im + hh.n * j + i) += tmp;
    }
    hh.oo_im = 0.0;  /*Flag that hh.oo_im has been added in*/
  }
  if (hh.gN_re)
  { for (i=0; i<hh.n; i++)
    { tmp = *(hh.gN_re + i) + hh.oo_re;
      for (j=0; j<hh.m; j++)
        *(hh.mat_re + hh.n * j + i) += tmp;
    }
    hh.oo_re = 0.0;  /*Flag that hh.oo_re has been added in*/
  }

  if (hh.gM_im)
    for (j=0; j<hh.m; j++)
    { tmp = *(hh.gM_im + j);
      for (i=0; i<hh.n; i++)
        *(hh.mat_im + hh.n * j + i) += tmp;
    }
  if (hh.gM_re)
    for (j=0; j<hh.m; j++)
    { tmp = *(hh.gM_re + j);
      for (i=0; i<hh.n; i++)
        *(hh.mat_re + hh.n * j + i) += tmp;
    }

  if (fabs(hh.oo_im)>TINY)
    for (i=0; i<hh.m*hh.n; i++)
      *(hh.mat_im + i) = hh.oo_im;
  if (hh.mat_re != NULL && fabs(hh.oo_re) > TINY)
    for (i=0; i<hh.m*hh.n; i++)
      *(hh.mat_re + i) = hh.oo_re;

  if (hh.gNm_im)
  { for (i=0; i<hh.n; i++)
    { tmp = *(hh.gNm_im + i) + hh.mo_im;
      for (j=0; j<hh.m; j += 2)
        *(hh.mat_im + hh.n * j + i) += tmp;
      for (j=1; j<hh.m; j += 2)
        *(hh.mat_im + hh.n * j + i) -= tmp;
    }
    hh.mo_im = 0.0;  /*Flag that hh.mo_im has been added in*/
  }
  if (hh.gNm_re)
  { for (i=0; i<hh.n; i++)
    { tmp = *(hh.gNm_re + i) + hh.mo_re;
      for (j=0; j<hh.m; j += 2)
        *(hh.mat_re + hh.n * j + i) += tmp;
      for (j=1; j<hh.m; j += 2)
        *(hh.mat_re + hh.n * j + i) -= tmp;
    }
    hh.mo_re = 0.0;  /*Flag that hh.mo_re has been added in*/
  }


  if (fabs(hh.mo_im)>TINY)
    for (i=0; i<hh.n; i++)
    { for (j=0; j<hh.m; j += 2)
        *(hh.mat_im + hh.n * j + i) += hh.mo_im;
      for (j=1; j<hh.m; j += 2)
        *(hh.mat_im + hh.n * j + i) -= hh.mo_im;
    }
  if (fabs(hh.mo_re)>TINY)
    for (i=0; i<hh.n; i++)
    { for (j=0; j<hh.m; j += 2)
        *(hh.mat_re + hh.n * j + i) += hh.mo_re;
      for (j=1; j<hh.m; j += 2)
        *(hh.mat_re + hh.n * j + i) -= hh.mo_re;
    }

  if (hh.gMn_im)
  { for (j=0; j<hh.m; j++)
    { tmp = *(hh.gMn_im + j) + hh.on_im;
      for (i=0; i<hh.n; i += 2)
	*(hh.mat_im + hh.n * j + i) += tmp;
      for (i=1; i<hh.n; i += 2)
	*(hh.mat_im + hh.n * j + i) -= tmp;
    }
    hh.on_im = 0.0;  /*Flag that hh.on_im has been added in*/
  }
  if (hh.gMn_re)
  { for (j=0; j<hh.m; j++)
    { tmp = *(hh.gMn_re + j) + hh.on_re;
      for (i=0; i<hh.n; i += 2)
	*(hh.mat_re + hh.n * j + i) += tmp;
      for (i=1; i<hh.n; i += 2)
	*(hh.mat_re + hh.n * j + i) -= tmp;
    }
    hh.on_re = 0.0;  /*Flag that hh.on_re has been added in*/
  }

  if (fabs(hh.on_im)>TINY)
    for (j=0; j<hh.m; j++)
    { for (i=0; i<hh.n; i += 2)
	*(hh.mat_im + hh.n * j + i) += hh.on_im;
      for (i=1; i<hh.n; i += 2)
	*(hh.mat_im + hh.n * j + i) -= hh.on_im;
    }
  if (fabs(hh.on_re)>TINY && hh.mat_re)
    for (j=0; j<hh.m; j++)
    { for (i=0; i<hh.n; i += 2)
	*(hh.mat_re + hh.n * j + i) += hh.on_re;
      for (i=1; i<hh.n; i += 2)
	*(hh.mat_re + hh.n * j + i) -= hh.on_re;
    }

  if (fabs(hh.mn_im)>TINY)
    for (j=0; j<hh.m; j++)
    { tmp = (j&1) ? -hh.mn_im : hh.mn_im;
      for (i=0; i<hh.n; i += 2)
	*(hh.mat_im + hh.n * j + i) += tmp;
      for (i=1; i<hh.n; i += 2)
	*(hh.mat_im + hh.n * j + i) -= tmp;
    }
  if (fabs(hh.mn_re)>TINY)
    for (j=0; j<hh.m; j++)
    { tmp = (j&1) ? -hh.mn_re : hh.mn_re;
      for (i=0; i<hh.n; i += 2)
	*(hh.mat_re + hh.n * j + i) += tmp;
      for (i=1; i<hh.n; i += 2)
	*(hh.mat_re + hh.n * j + i) -= tmp;
    }

} /*reduce_h*/

qdo_coup( ps,pf,S ) msub_list *ps,*pf;  Ssmat_ptr S;
/*************************************************************/
/* Calculate coupling between subsections.                   */
/* (C) COPYRIGHT 1986 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr27may87 */ 
/* jcr02oct88 modified for general subsections*/
/* jcr24may89 modified for fast load using wt, be sure to use do_coup_init!*/
/* jcr13jul92 modified for quad prec. option*/
{ msub *src,*fld,*srclim,*fldlim;
  RRtyp sre,sim,tmp,tmp2;
  Rtyp *rts0,*rtf0,*rts,*sbeg,*rtf,*fbeg,*fend;
  wt_info *wts,*wtf,*wts0,*wtf0;
  Rtyp *wt,*wtx,*wty;
  Rtyp *iwt,*jwt,*kwt,*wend;
  int xsum0,xsum1,xdif0,xdif1,ysum0,ysum1,ydif0,ydif1;
  int dxs,dxd,dys,dyd,neg_xsum,neg_xdif,neg_ysum,neg_ydif;
  int ns,nf,nwtx,nwty,x,y;
  int pos,irow,icol,irow_end,icol_end;
  int scnd,ssubloc,fsubloc;
  int twonm1;  /* 2*N-1, where system matrix is NxN*/

  qreduce_h();

  /*used in addr calc for S*/
  twonm1 = 2 * S->n - 1;

  scnd = 0;  /*Set to 1 for 2nd time thru*/
  ssubloc = src_sub_loc;  fsubloc = fld_sub_loc;

  /*field then source subsection loop*/
  while (scnd<2)
  { for (fld=pf->msub0,fldlim=fld+pf->n; fld<fldlim; fld++)
    if ( (wtf0 = *(wt0+NUM_ESUB*fld->loc+fsubloc)) != NULL )
      for (src=(ps==pf)?fld:ps->msub0,srclim=ps->msub0+ps->n; src<srclim; src++)
	if ( ( (wts0 = *(wt0+NUM_ESUB*src->loc+ssubloc)) != NULL ) && ( !scnd || src!=fld ) )
	{ if (scnd) { wtf = wts0;  wts = wtf0; }
	  else      { wtf = wtf0;  wts = wts0; }

	  /************************************************************/
          /*** Calculate the convolved wt vectors, start with x sum ***/
	  /************************************************************/
	  rts0 = wts->wx;  rtf0 = wtf->wx;
	  ns = (wts->ex1 - wts->ex0)/2;  /*one less than usual, for limit is <=*/
	  nf = (wtf->ex1 - wtf->ex0)/2;
	  nwtx = ns + nf + 1;  /*for the usual < limit*/
	  for (wt=wxsum,x=0; x<nwtx; wt++,x++)
          { fend = rtf0 + ((nf<x) ? nf : x);  fbeg = rtf0 + ((ns<x) ? x-ns : 0);
	    sbeg = rts0 + ((ns<x) ? ns : x);  *wt = 0.0;
	    for (rtf=fbeg,rts=sbeg; rtf<=fend; rtf++,rts--) *wt += *rtf * *rts;
          }
	  /*x difference vector*/
	  for (wt=wxdif,x= -nf; x<=ns; wt++,x++)
          { fend = rtf0 + ((nf<ns-x) ? nf : ns-x);  fbeg = rtf0 + ((x>=0) ? 0 : -x);
	    sbeg = rts0 + ((x>0) ? x : 0);  *wt = 0.0;
	    for (rtf=fbeg,rts=sbeg; rtf<=fend; rtf++,rts++) *wt += *rtf * *rts;
          }
	  /*y sum vector*/
	  rts0 = wts->wy;  rtf0 = wtf->wy;
	  ns = (wts->ey1 - wts->ey0)/2;  /*one less than usual, for limit is <=*/
	  nf = (wtf->ey1 - wtf->ey0)/2;
	  nwty = ns + nf + 1;  /*for the usual < limit*/
	  for (wt=wysum,y=0; y<nwty; wt++,y++)
          { fend = rtf0 + ((nf<y) ? nf : y);  fbeg = rtf0 + ((ns<y) ? y-ns : 0);
	    sbeg = rts0 + ((ns<y) ? ns : y);  *wt = 0.0;
	    for (rtf=fbeg,rts=sbeg; rtf<=fend; rtf++,rts--) *wt += *rtf * *rts;
          }
	  /*y difference vector*/
	  for (wt=wydif,y= -nf; y<=ns; wt++,y++)
          { fend = rtf0 + ((nf<ns-y) ? nf : ns-y);  fbeg = rtf0 + ((y>=0) ? 0 : -y);
	    sbeg = rts0 + ((y>0) ? y : 0);  *wt = 0.0;
	    for (rtf=fbeg,rts=sbeg; rtf<=fend; rtf++,rts++) *wt += *rtf * *rts;
          }

	  /*********************************************************/
          /*** Calculate the limits and, if necessary, fold back ***/
	  /*********************************************************/
          xsum0 = wts->ex0 + wtf->ex0;  xsum1 = wts->ex1 + wtf->ex1;  neg_xsum = Spx;
          if (xsum0>Capm) /*Re-map limits*/
	  { xsum0 = 2*Capm - xsum0;  xsum1 = 2*Capm - xsum1;
	    if (!gx) neg_xsum = !neg_xsum;
	    xsum0 = xsum0>>1;  xsum1 = xsum1>>1;  dxs = -1;
          }
	  else if (xsum1>Capm)
	  { for (jwt=wtswp,wend=wtswp+nwtx; jwt<wend; jwt++) *jwt = 0.0;
	    x = (Capm - xsum0)>>1;
            for (iwt=wxsum+x,jwt=wtswp; iwt>=wxsum; iwt--,jwt++) *jwt = *iwt;
	    iwt = wxsum + x + 1;  jwt = wtswp + !(xsum0&1);  wend = wxsum + nwtx;
            if (!gx) for ( ; iwt<wend; iwt++,jwt++) *jwt -= *iwt;
            else         for ( ; iwt<wend; iwt++,jwt++) *jwt += *iwt;
	    xsum1 = 2*Capm - xsum1;  xsum1 = (xsum0<xsum1) ? xsum0>>1 : xsum1>>1;
	    xsum0 = Capm2 - (xsum0&1);  dxs = -1;
            for (iwt=wtswp,jwt=wxsum,wend=wtswp+(xsum0-xsum1); iwt<=wend; iwt++,jwt++) *jwt = *iwt;
          }
	  else { xsum0 = xsum0>>1;  xsum1 = xsum1>>1;  dxs = 1; }

          /*x difference*/
          xdif0 = wts->ex0 - wtf->ex1;  xdif1 = wts->ex1 - wtf->ex0;  neg_xdif = Smx;
          if (xdif1<0) /*Re-map limits*/
	  { xdif0 = -xdif0;  xdif1 = -xdif1;  if (!gx) neg_xdif = !neg_xdif;
	    xdif0 = xdif0>>1;  xdif1 = xdif1>>1;  dxd = -1;
          }
	  else if (xdif0<0)
	  { for (jwt=wtswp,wend=wtswp+nwtx; jwt<wend; jwt++) *jwt = 0.0;
	    { iwt = kwt =  wxdif + nwtx - 1 - (xdif1>>1);
	      for (jwt=wtswp,wend=wxdif+nwtx; iwt<wend; iwt++,jwt++) *jwt = *iwt;
	      iwt = kwt - 1;  jwt = wtswp + !(xdif0&1);
              if (!gx) for ( ; iwt>=wxdif; iwt--,jwt++) *jwt -= *iwt;
              else     for ( ; iwt>=wxdif; iwt--,jwt++) *jwt += *iwt;
	    }
	    xdif0 = abs(xdif0);  xdif1 = abs(xdif1);  dxd = 1;
	    xdif1 = (xdif0>xdif1) ? xdif0>>1 : xdif1>>1;  xdif0 = 0;
            for (iwt=wtswp,jwt=wxdif,wend=wtswp+xdif1; iwt<=wend; iwt++,jwt++) *jwt = *iwt;
          }
	  else { xdif0 = xdif0>>1;  xdif1 = xdif1>>1;  dxd = 1; }

          /*y sum*/
          ysum0 = wts->ey0 + wtf->ey0;  ysum1 = wts->ey1 + wtf->ey1;  neg_ysum = Spy;
          if (ysum0>(Capn>>xsym)) /*Re-map limits*/
	  { ysum0 = (Capn<<(!xsym)) - ysum0;  ysum1 = (Capn<<(!xsym)) - ysum1;
	    if ( gy==xsym ) neg_ysum = !neg_ysum;
	    ysum0 = ysum0>>1;  ysum1 = ysum1>>1;  dys = -1;
          }
	  else if (ysum1>(Capn>>xsym))
	  { for (jwt=wtswp,wend=wtswp+nwty; jwt<wend; jwt++) *jwt = 0.0;
	    y = ((Capn>>xsym) - ysum0)>>1;
            for (iwt=wysum+y,jwt=wtswp; iwt>=wysum; iwt--,jwt++) *jwt = *iwt;
	    iwt = wysum + y + 1;  /*jwt = wtswp + !(ysum0&1);*/  wend = wysum + nwty;
	    jwt = wtswp + ( (ysum0&1) == ((Capn>>xsym)&1) );
            if (gy==xsym) for ( ; iwt<wend; iwt++,jwt++) *jwt -= *iwt;
            else                 for ( ; iwt<wend; iwt++,jwt++) *jwt += *iwt;
	    ysum1 = (Capn<<(!xsym)) - ysum1;  ysum1 = (ysum0<ysum1) ? ysum0>>1 : ysum1>>1;
	    ysum0 = ((Capn>>xsym)-(ysum0&1))>>1;  dys = -1;
            for (iwt=wtswp,jwt=wysum,wend=wtswp+(ysum0-ysum1); iwt<=wend; iwt++,jwt++) *jwt = *iwt;
          }
	  else { ysum0 = ysum0>>1;  ysum1 = ysum1>>1;  dys = 1; }

          /*y difference*/
          ydif0 = wts->ey0 - wtf->ey1;  ydif1 = wts->ey1 - wtf->ey0;  neg_ydif = Smy;
          if (ydif1<0) /*Re-map limits*/
	  { ydif0 = -ydif0;  ydif1 = -ydif1;  if (!gy) neg_ydif = !neg_ydif;
	    ydif0 = ydif0>>1;  ydif1 = ydif1>>1;  dyd = -1;
          }
	  else if (ydif0<0)
	  { for (jwt=wtswp,wend=wtswp+nwty; jwt<wend; jwt++) *jwt = 0.0;
	    { iwt = kwt =  wydif + nwty - 1 - (ydif1>>1);
	      for (jwt=wtswp,wend=wydif+nwty; iwt<wend; iwt++,jwt++) *jwt = *iwt;
	      iwt = kwt - 1;  jwt = wtswp + !(ydif0&1);
              if (!gy) for ( ; iwt>=wydif; iwt--,jwt++) *jwt -= *iwt;
              else          for ( ; iwt>=wydif; iwt--,jwt++) *jwt += *iwt;
	    }
	    ydif0 = abs(ydif0);  ydif1 = abs(ydif1);  dyd = 1;
	    ydif1 = (ydif0>ydif1) ? ydif0>>1 : ydif1>>1;  ydif0 = 0;
            for (iwt=wtswp,jwt=wydif,wend=wtswp+ydif1; iwt<=wend; iwt++,jwt++) *jwt = *iwt;
          }
	  else { ydif0 = ydif0>>1;  ydif1 = ydif1>>1;  dyd = 1; }

	  /************************************************/
          /*** Evaluate the matrix part of the summation **/
	  /************************************************/
	  /*Do the sumx.sumy part first*/
          tmp2 = 0.0;  wtx = wxsum;  irow = xsum0;  irow_end = xsum1 + dxs;
	  while (irow != irow_end)
          { tmp = 0.0;  wty = wysum;  icol = ysum0;  icol_end = ysum1 + dys;
	    while (icol != icol_end)
	    { tmp += *(qhh.mat_im + qhh.n * irow + icol) * *wty;  icol += dys;  wty++; }
	    tmp2 += tmp * *wtx;  irow += dxs;  wtx++;
          }
          sim = (neg_xsum^neg_ysum) ? -tmp2 : tmp2;

	  /*Do the sumx.dify part*/
          tmp2 = 0.0;  wtx = wxsum;  irow = xsum0;  irow_end = xsum1 + dxs;
	  while (irow != irow_end)
          { tmp = 0.0;  wty = wydif;  icol = ydif0;  icol_end = ydif1 + dyd;
	    while (icol != icol_end)
	    { tmp += *(qhh.mat_im + qhh.n * irow + icol) * *wty;  icol += dyd;  wty++; }
	    tmp2 += tmp * *wtx;  irow += dxs;  wtx++;
          }
          sim += (neg_xsum^neg_ydif) ? -tmp2 : tmp2;

	  /*Do the difx.sumy part*/
          tmp2 = 0.0;  wtx = wxdif;  irow = xdif0;  irow_end = xdif1 + dxd;
	  while (irow != irow_end)
          { tmp = 0.0;  wty = wysum;  icol = ysum0;  icol_end = ysum1 + dys;
	    while (icol != icol_end)
	    { tmp += *(qhh.mat_im + qhh.n * irow + icol) * *wty;  icol += dys;  wty++; }
	    tmp2 += tmp * *wtx;  irow += dxd;  wtx++;
          }
          sim += (neg_xdif^neg_ysum) ? -tmp2 : tmp2;

	  /*Do the difx.dify part*/
          tmp2 = 0.0;  wtx = wxdif;  irow = xdif0;  irow_end = xdif1 + dxd;
	  while (irow != irow_end)
          { tmp = 0.0;  wty = wydif;  icol = ydif0;  icol_end = ydif1 + dyd;
	    while (icol != icol_end)
	    { tmp += *(qhh.mat_im + qhh.n * irow + icol) * *wty;  icol += dyd;  wty++; }
	    tmp2 += tmp * *wtx;  irow += dxd;  wtx++;
          }
          sim += (neg_xdif^neg_ydif) ? -tmp2 : tmp2;

          /*If self msub coupling and not self esub coupling, double*/
          if (src==fld && ssubloc!=fsubloc) sim *= 2.0;

          irow = fld->loc;  icol = src->loc;
          if (irow>icol) { irow = src->loc;  icol = fld->loc; }
          pos = icol + ((irow*(twonm1 - irow))>>1);

          if (S->d) *(S->Im+pos) += sim;
          else      *(S->im+pos) += sim;

	  /******************************************************/
	  /*** Evaluate the real part of the of the summation ***/
	  /******************************************************/
	  if (loss)
	  { /*Do the sumx.sumy part first*/
            tmp2 = 0.0;  wtx = wxsum;  irow = xsum0;  irow_end = xsum1 + dxs;
	    while (irow != irow_end)
            { tmp = 0.0;  wty = wysum;  icol = ysum0;  icol_end = ysum1 + dys;
	      while (icol != icol_end)
  	      { tmp += *(qhh.mat_re + qhh.n * irow + icol) * *wty;  icol += dys;  wty++; }
	      tmp2 += tmp * *wtx;  irow += dxs;  wtx++;
            }
            sre = (neg_xsum^neg_ysum) ? -tmp2 : tmp2;

	    /*Do the sumx.dify part*/
            tmp2 = 0.0;  wtx = wxsum;  irow = xsum0;  irow_end = xsum1 + dxs;
	    while (irow != irow_end)
            { tmp = 0.0;  wty = wydif;  icol = ydif0;  icol_end = ydif1 + dyd;
	      while (icol != icol_end)
	      { tmp += *(qhh.mat_re + qhh.n * irow + icol) * *wty;  icol += dyd;  wty++; }
	      tmp2 += tmp * *wtx;  irow += dxs;  wtx++;
            }
            sre += (neg_xsum^neg_ydif) ? -tmp2 : tmp2;

	    /*Do the difx.sumy part*/
            tmp2 = 0.0;  wtx = wxdif;  irow = xdif0;  irow_end = xdif1 + dxd;
	    while (irow != irow_end)
            { tmp = 0.0;  wty = wysum;  icol = ysum0;  icol_end = ysum1 + dys;
	      while (icol != icol_end)
	      { tmp += *(qhh.mat_re + qhh.n * irow + icol) * *wty;  icol += dys;  wty++; }
	      tmp2 += tmp * *wtx;  irow += dxd;  wtx++;
            }
            sre += (neg_xdif^neg_ysum) ? -tmp2 : tmp2;

	    /*Do the difx.dify part*/
            tmp2 = 0.0;  wtx = wxdif;  irow = xdif0;  irow_end = xdif1 + dxd;
	    while (irow != irow_end)
            { tmp = 0.0;  wty = wydif;  icol = ydif0;  icol_end = ydif1 + dyd;
	      while (icol != icol_end)
	      { tmp += *(qhh.mat_re + qhh.n * irow + icol) * *wty;  icol += dyd;  wty++; }
	      tmp2 += tmp * *wtx;  irow += dxd;  wtx++;
            }
            sre += (neg_xdif^neg_ydif) ? -tmp2 : tmp2;

            /*If self msub coupling and not self esub coupling, double*/
            if (src==fld && ssubloc!=fsubloc) sre *= 2.0;

            if (S->d) *(S->Re+pos) += sre;
            else      *(S->re+pos) += sre;
          }
        }
    /*If not self esub coupling (below) and not self msub coupling (beginning of loop),*/
    /*repeat with src and fld swapped to pick up any x-y/y-x couplings missed*/
    if (ssubloc==fsubloc) break;
    /*Do not repeat if src xor fld is via and different layers*/
    if ( ps!=pf && ( (ssubloc==VIA) != (fsubloc==VIA) ) ) break;
    scnd++;  x = fsubloc;  fsubloc = ssubloc;  ssubloc = x;
  }
} /*qdo_coup*/

do_coup( ps,pf,S ) msub_list *ps,*pf;  Ssmat_ptr S;
/*************************************************************/
/* Calculate coupling between subsections.                   */
/* (C) COPYRIGHT 1986 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr27may87 */ 
/* jcr02oct88 modified for general subsections*/
/* jcr24may89 modified for fast load using wt, be sure to use do_coup_init!*/
{ msub *src,*fld,*srclim,*fldlim;
  Rtyp sre,sim;
  Rtyp *rts0,*rtf0,*rts,*sbeg,*rtf,*fbeg,*fend;
  wt_info *wts,*wtf,*wts0,*wtf0;
  Rtyp *wt,*wtx,*wty,tmp,tmp2;
  Rtyp *iwt,*jwt,*kwt,*wend;
  int xsum0,xsum1,xdif0,xdif1,ysum0,ysum1,ydif0,ydif1;
  int dxs,dxd,dys,dyd,neg_xsum,neg_xdif,neg_ysum,neg_ydif;
  int ns,nf,nwtx,nwty,x,y;
  int pos,irow,icol,irow_end,icol_end;
  int scnd,ssubloc,fsubloc;
  int twonm1;  /* 2*N-1, where system matrix is NxN*/

  reduce_h();

  /*used in addr calc for S*/
  twonm1 = 2 * S->n - 1;

  scnd = 0;  /*Set to 1 for 2nd time thru*/
  ssubloc = src_sub_loc;  fsubloc = fld_sub_loc;

  /*field then source subsection loop*/
  while (scnd<2)
  { for (fld=pf->msub0,fldlim=fld+pf->n; fld<fldlim; fld++)
    if ( (wtf0 = *(wt0+NUM_ESUB*fld->loc+fsubloc)) != NULL )
      for (src=(ps==pf)?fld:ps->msub0,srclim=ps->msub0+ps->n; src<srclim; src++)
	if ( ( (wts0 = *(wt0+NUM_ESUB*src->loc+ssubloc)) != NULL ) && ( !scnd || src!=fld ) )
	{ if (scnd) { wtf = wts0;  wts = wtf0; }
	  else      { wtf = wtf0;  wts = wts0; }

	  /************************************************************/
          /*** Calculate the convolved wt vectors, start with x sum ***/
	  /************************************************************/
	  rts0 = wts->wx;  rtf0 = wtf->wx;
	  ns = (wts->ex1 - wts->ex0)/2;  /*one less than usual, for limit is <=*/
	  nf = (wtf->ex1 - wtf->ex0)/2;
	  nwtx = ns + nf + 1;  /*for the usual < limit*/
	  for (wt=wxsum,x=0; x<nwtx; wt++,x++)
          { fend = rtf0 + ((nf<x) ? nf : x);  fbeg = rtf0 + ((ns<x) ? x-ns : 0);
	    sbeg = rts0 + ((ns<x) ? ns : x);  *wt = 0.0;
	    for (rtf=fbeg,rts=sbeg; rtf<=fend; rtf++,rts--) *wt += *rtf * *rts;
          }
	  /*x difference vector*/
	  for (wt=wxdif,x= -nf; x<=ns; wt++,x++)
          { fend = rtf0 + ((nf<ns-x) ? nf : ns-x);  fbeg = rtf0 + ((x>=0) ? 0 : -x);
	    sbeg = rts0 + ((x>0) ? x : 0);  *wt = 0.0;
	    for (rtf=fbeg,rts=sbeg; rtf<=fend; rtf++,rts++) *wt += *rtf * *rts;
          }
	  /*y sum vector*/
	  rts0 = wts->wy;  rtf0 = wtf->wy;
	  ns = (wts->ey1 - wts->ey0)/2;  /*one less than usual, for limit is <=*/
	  nf = (wtf->ey1 - wtf->ey0)/2;
	  nwty = ns + nf + 1;  /*for the usual < limit*/
	  for (wt=wysum,y=0; y<nwty; wt++,y++)
          { fend = rtf0 + ((nf<y) ? nf : y);  fbeg = rtf0 + ((ns<y) ? y-ns : 0);
	    sbeg = rts0 + ((ns<y) ? ns : y);  *wt = 0.0;
	    for (rtf=fbeg,rts=sbeg; rtf<=fend; rtf++,rts--) *wt += *rtf * *rts;
          }
	  /*y difference vector*/
	  for (wt=wydif,y= -nf; y<=ns; wt++,y++)
          { fend = rtf0 + ((nf<ns-y) ? nf : ns-y);  fbeg = rtf0 + ((y>=0) ? 0 : -y);
	    sbeg = rts0 + ((y>0) ? y : 0);  *wt = 0.0;
	    for (rtf=fbeg,rts=sbeg; rtf<=fend; rtf++,rts++) *wt += *rtf * *rts;
          }

	  /*********************************************************/
          /*** Calculate the limits and, if necessary, fold back ***/
	  /*********************************************************/
          xsum0 = wts->ex0 + wtf->ex0;  xsum1 = wts->ex1 + wtf->ex1;  neg_xsum = Spx;
          if (xsum0>Capm) /*Re-map limits*/
	  { xsum0 = 2*Capm - xsum0;  xsum1 = 2*Capm - xsum1;
	    if (!gx) neg_xsum = !neg_xsum;
	    xsum0 = xsum0>>1;  xsum1 = xsum1>>1;  dxs = -1;
          }
	  else if (xsum1>Capm)
	  { for (jwt=wtswp,wend=wtswp+nwtx; jwt<wend; jwt++) *jwt = 0.0;
	    x = (Capm - xsum0)>>1;
            for (iwt=wxsum+x,jwt=wtswp; iwt>=wxsum; iwt--,jwt++) *jwt = *iwt;
	    iwt = wxsum + x + 1;  jwt = wtswp + !(xsum0&1);  wend = wxsum + nwtx;
            if (!gx) for ( ; iwt<wend; iwt++,jwt++) *jwt -= *iwt;
            else         for ( ; iwt<wend; iwt++,jwt++) *jwt += *iwt;
	    xsum1 = 2*Capm - xsum1;  xsum1 = (xsum0<xsum1) ? xsum0>>1 : xsum1>>1;
	    xsum0 = Capm2 - (xsum0&1);  dxs = -1;
            for (iwt=wtswp,jwt=wxsum,wend=wtswp+(xsum0-xsum1); iwt<=wend; iwt++,jwt++) *jwt = *iwt;
          }
	  else { xsum0 = xsum0>>1;  xsum1 = xsum1>>1;  dxs = 1; }

          /*x difference*/
          xdif0 = wts->ex0 - wtf->ex1;  xdif1 = wts->ex1 - wtf->ex0;  neg_xdif = Smx;
          if (xdif1<0) /*Re-map limits*/
	  { xdif0 = -xdif0;  xdif1 = -xdif1;  if (!gx) neg_xdif = !neg_xdif;
	    xdif0 = xdif0>>1;  xdif1 = xdif1>>1;  dxd = -1;
          }
	  else if (xdif0<0)
	  { for (jwt=wtswp,wend=wtswp+nwtx; jwt<wend; jwt++) *jwt = 0.0;
	    { iwt = kwt =  wxdif + nwtx - 1 - (xdif1>>1);
	      for (jwt=wtswp,wend=wxdif+nwtx; iwt<wend; iwt++,jwt++) *jwt = *iwt;
	      iwt = kwt - 1;  jwt = wtswp + !(xdif0&1);
              if (!gx) for ( ; iwt>=wxdif; iwt--,jwt++) *jwt -= *iwt;
              else     for ( ; iwt>=wxdif; iwt--,jwt++) *jwt += *iwt;
	    }
	    xdif0 = abs(xdif0);  xdif1 = abs(xdif1);  dxd = 1;
	    xdif1 = (xdif0>xdif1) ? xdif0>>1 : xdif1>>1;  xdif0 = 0;
            for (iwt=wtswp,jwt=wxdif,wend=wtswp+xdif1; iwt<=wend; iwt++,jwt++) *jwt = *iwt;
          }
	  else { xdif0 = xdif0>>1;  xdif1 = xdif1>>1;  dxd = 1; }

          /*y sum*/
          ysum0 = wts->ey0 + wtf->ey0;  ysum1 = wts->ey1 + wtf->ey1;  neg_ysum = Spy;
          if (ysum0>(Capn>>xsym)) /*Re-map limits*/
	  { ysum0 = (Capn<<(!xsym)) - ysum0;  ysum1 = (Capn<<(!xsym)) - ysum1;
	    if ( gy==xsym ) neg_ysum = !neg_ysum;
	    ysum0 = ysum0>>1;  ysum1 = ysum1>>1;  dys = -1;
          }
	  else if (ysum1>(Capn>>xsym))
	  { for (jwt=wtswp,wend=wtswp+nwty; jwt<wend; jwt++) *jwt = 0.0;
	    y = ((Capn>>xsym) - ysum0)>>1;
            for (iwt=wysum+y,jwt=wtswp; iwt>=wysum; iwt--,jwt++) *jwt = *iwt;
	    iwt = wysum + y + 1;  /*jwt = wtswp + !(ysum0&1);*/  wend = wysum + nwty;
	    jwt = wtswp + ( (ysum0&1) == ((Capn>>xsym)&1) );
            if (gy==xsym) for ( ; iwt<wend; iwt++,jwt++) *jwt -= *iwt;
            else                 for ( ; iwt<wend; iwt++,jwt++) *jwt += *iwt;
	    ysum1 = (Capn<<(!xsym)) - ysum1;  ysum1 = (ysum0<ysum1) ? ysum0>>1 : ysum1>>1;
	    ysum0 = ((Capn>>xsym)-(ysum0&1))>>1;  dys = -1;
            for (iwt=wtswp,jwt=wysum,wend=wtswp+(ysum0-ysum1); iwt<=wend; iwt++,jwt++) *jwt = *iwt;
          }
	  else { ysum0 = ysum0>>1;  ysum1 = ysum1>>1;  dys = 1; }

          /*y difference*/
          ydif0 = wts->ey0 - wtf->ey1;  ydif1 = wts->ey1 - wtf->ey0;  neg_ydif = Smy;
          if (ydif1<0) /*Re-map limits*/
	  { ydif0 = -ydif0;  ydif1 = -ydif1;  if (!gy) neg_ydif = !neg_ydif;
	    ydif0 = ydif0>>1;  ydif1 = ydif1>>1;  dyd = -1;
          }
	  else if (ydif0<0)
	  { for (jwt=wtswp,wend=wtswp+nwty; jwt<wend; jwt++) *jwt = 0.0;
	    { iwt = kwt =  wydif + nwty - 1 - (ydif1>>1);
	      for (jwt=wtswp,wend=wydif+nwty; iwt<wend; iwt++,jwt++) *jwt = *iwt;
	      iwt = kwt - 1;  jwt = wtswp + !(ydif0&1);
              if (!gy) for ( ; iwt>=wydif; iwt--,jwt++) *jwt -= *iwt;
              else          for ( ; iwt>=wydif; iwt--,jwt++) *jwt += *iwt;
	    }
	    ydif0 = abs(ydif0);  ydif1 = abs(ydif1);  dyd = 1;
	    ydif1 = (ydif0>ydif1) ? ydif0>>1 : ydif1>>1;  ydif0 = 0;
            for (iwt=wtswp,jwt=wydif,wend=wtswp+ydif1; iwt<=wend; iwt++,jwt++) *jwt = *iwt;
          }
	  else { ydif0 = ydif0>>1;  ydif1 = ydif1>>1;  dyd = 1; }

	  /************************************************/
          /*** Evaluate the matrix part of the summation **/
	  /************************************************/
	  /*Do the sumx.sumy part first*/
          tmp2 = 0.0;  wtx = wxsum;  irow = xsum0;  irow_end = xsum1 + dxs;
	  while (irow != irow_end)
          { tmp = 0.0;  wty = wysum;  icol = ysum0;  icol_end = ysum1 + dys;
	    while (icol != icol_end)
	    { tmp += *(hh.mat_im + hh.n * irow + icol) * *wty;  icol += dys;  wty++; }
	    tmp2 += tmp * *wtx;  irow += dxs;  wtx++;
          }
          sim = (neg_xsum^neg_ysum) ? -tmp2 : tmp2;

	  /*Do the sumx.dify part*/
          tmp2 = 0.0;  wtx = wxsum;  irow = xsum0;  irow_end = xsum1 + dxs;
	  while (irow != irow_end)
          { tmp = 0.0;  wty = wydif;  icol = ydif0;  icol_end = ydif1 + dyd;
	    while (icol != icol_end)
	    { tmp += *(hh.mat_im + hh.n * irow + icol) * *wty;  icol += dyd;  wty++; }
	    tmp2 += tmp * *wtx;  irow += dxs;  wtx++;
          }
          sim += (neg_xsum^neg_ydif) ? -tmp2 : tmp2;

	  /*Do the difx.sumy part*/
          tmp2 = 0.0;  wtx = wxdif;  irow = xdif0;  irow_end = xdif1 + dxd;
	  while (irow != irow_end)
          { tmp = 0.0;  wty = wysum;  icol = ysum0;  icol_end = ysum1 + dys;
	    while (icol != icol_end)
	    { tmp += *(hh.mat_im + hh.n * irow + icol) * *wty;  icol += dys;  wty++; }
	    tmp2 += tmp * *wtx;  irow += dxd;  wtx++;
          }
          sim += (neg_xdif^neg_ysum) ? -tmp2 : tmp2;

	  /*Do the difx.dify part*/
          tmp2 = 0.0;  wtx = wxdif;  irow = xdif0;  irow_end = xdif1 + dxd;
	  while (irow != irow_end)
          { tmp = 0.0;  wty = wydif;  icol = ydif0;  icol_end = ydif1 + dyd;
	    while (icol != icol_end)
	    { tmp += *(hh.mat_im + hh.n * irow + icol) * *wty;  icol += dyd;  wty++; }
	    tmp2 += tmp * *wtx;  irow += dxd;  wtx++;
          }
          sim += (neg_xdif^neg_ydif) ? -tmp2 : tmp2;

          /*If self msub coupling and not self esub coupling, double*/
          if (src==fld && ssubloc!=fsubloc) sim *= 2.0;

          irow = fld->loc;  icol = src->loc;
          if (irow>icol) { irow = src->loc;  icol = fld->loc; }
          pos = icol + ((irow*(twonm1 - irow))>>1);

          if (S->d) *(S->Im+pos) += sim;
          else      *(S->im+pos) += sim;

	  /******************************************************/
	  /*** Evaluate the real part of the of the summation ***/
	  /******************************************************/
	  if (loss)
	  { /*Do the sumx.sumy part first*/
            tmp2 = 0.0;  wtx = wxsum;  irow = xsum0;  irow_end = xsum1 + dxs;
	    while (irow != irow_end)
            { tmp = 0.0;  wty = wysum;  icol = ysum0;  icol_end = ysum1 + dys;
	      while (icol != icol_end)
  	      { tmp += *(hh.mat_re + hh.n * irow + icol) * *wty;  icol += dys;  wty++; }
	      tmp2 += tmp * *wtx;  irow += dxs;  wtx++;
            }
            sre = (neg_xsum^neg_ysum) ? -tmp2 : tmp2;

	    /*Do the sumx.dify part*/
            tmp2 = 0.0;  wtx = wxsum;  irow = xsum0;  irow_end = xsum1 + dxs;
	    while (irow != irow_end)
            { tmp = 0.0;  wty = wydif;  icol = ydif0;  icol_end = ydif1 + dyd;
	      while (icol != icol_end)
	      { tmp += *(hh.mat_re + hh.n * irow + icol) * *wty;  icol += dyd;  wty++; }
	      tmp2 += tmp * *wtx;  irow += dxs;  wtx++;
            }
            sre += (neg_xsum^neg_ydif) ? -tmp2 : tmp2;

	    /*Do the difx.sumy part*/
            tmp2 = 0.0;  wtx = wxdif;  irow = xdif0;  irow_end = xdif1 + dxd;
	    while (irow != irow_end)
            { tmp = 0.0;  wty = wysum;  icol = ysum0;  icol_end = ysum1 + dys;
	      while (icol != icol_end)
	      { tmp += *(hh.mat_re + hh.n * irow + icol) * *wty;  icol += dys;  wty++; }
	      tmp2 += tmp * *wtx;  irow += dxd;  wtx++;
            }
            sre += (neg_xdif^neg_ysum) ? -tmp2 : tmp2;

	    /*Do the difx.dify part*/
            tmp2 = 0.0;  wtx = wxdif;  irow = xdif0;  irow_end = xdif1 + dxd;
	    while (irow != irow_end)
            { tmp = 0.0;  wty = wydif;  icol = ydif0;  icol_end = ydif1 + dyd;
	      while (icol != icol_end)
	      { tmp += *(hh.mat_re + hh.n * irow + icol) * *wty;  icol += dyd;  wty++; }
	      tmp2 += tmp * *wtx;  irow += dxd;  wtx++;
            }
            sre += (neg_xdif^neg_ydif) ? -tmp2 : tmp2;

            /*If self msub coupling and not self esub coupling, double*/
            if (src==fld && ssubloc!=fsubloc) sre *= 2.0;

            if (S->d) *(S->Re+pos) += sre;
            else      *(S->re+pos) += sre;
          }
        }
    /*If not self esub coupling (below) and not self msub coupling (beginning of loop),*/
    /*repeat with src and fld swapped to pick up any x-y/y-x couplings missed*/
    if (ssubloc==fsubloc) break;
    /*Do not repeat if src xor fld is via and different layers*/
    if ( ps!=pf && ( (ssubloc==VIA) != (fsubloc==VIA) ) ) break;
    scnd++;  x = fsubloc;  fsubloc = ssubloc;  ssubloc = x;
  }
} /*do_coup*/
